<?php
 /** 
 * @version        
 * @package        ecfirm
 * @subpackage    
 * @copyright    Copyright (C) 2011 Kilmeny.net. All rights reserved.
 * @license        GNU General Public License version 2 or later. 
 **/
  
defined('_JEXEC') or die('Restricted access'); 
// website root directory
$_root = JURI::root();
$ordering = ( ($this->lists['order'] == 'ordering' || $this->lists['order'] == 'id, ordering'));
$image_yes = $_root . "administrator/templates/bluestork/images/admin/tick.png";
$image_no  = $_root . "administrator/templates/bluestork/images/admin/publish_x.png";
?>

<form action="index.php" method="post" name="adminForm" id="adminForm">
	<table class="adminform">
		<tr>
			<td width="100%">
			  	<?php echo JText::_( 'SEARCH' ); ?>
				<input type="text" name="search" id="search" value="<?php echo $this->lists['search']; ?>" 
					class="text_area" onChange="document.adminForm.submit();" />
				<button onclick="this.form.submit();"><?php echo JText::_( 'GO' ); ?></button>
				<button onclick="this.form.getElementById('search').value='';this.form.submit();"><?php echo JText::_( 'RESET' ); ?></button>
			</td>
		</tr>
	</table>
	<table class="adminlist" cellspacing="1">
	<thead>
		<tr>
			<th width="5"><?php echo JText::_( 'ECFIRM_NUM' ); ?></th>
			<th width="5"><input type="checkbox" name="toggle" value="" onClick="checkAll(<?php echo count( $this->rows ); ?>);" /></th>
			<th class="title" style="text-align: left;"><?php echo JText::_( 'ECFIRM_USERNAME' ); ?></th>
			<th width="10"><?php echo JText::_( 'ECFIRM_POSTS' ); ?></th>
			<th width="100" style="text-align: left;"><?php echo JText::_( 'ECFIRM_TITLE' ); ?></th>
			<th width="100" style="text-align: left;"><?php echo JText::_( 'ECFIRM_COUNTRY' ); ?></th>
			<th width="10"><?php echo JText::_( 'ECFIRM_SHOW_STATUS' ); ?></th>
			<th width="10"><?php echo JText::_( 'ECFIRM_MODERATOR' ); ?></th>
			<th width="10"><?php echo JText::_( 'ECFIRM_EMAIL' ); ?></th>
			<th width="10"><?php echo JText::_( 'ECFIRM_APPROVAL' ); ?></th>
			<th width="10"><?php echo JText::_( 'ECFIRM_MODERATED' ); ?></th>
			<th width="10"><?php echo JText::_( 'ECFIRM_ROOKIE' ); ?></th>
			<th width="10"><?php echo JText::_( 'ECFIRM_TRUSTED' ); ?></th>
			<th width="10"><?php echo JText::_( 'ECFIRM_IMAGES' ); ?></th>
			<th width="10"><?php echo JText::_( 'ID' ); ?></th>
		</tr>
	</thead>
	<tfoot>
		<tr>
			<td colspan="15">
				<?php echo $this->pageNav->getListFooter(); ?>
			</td>
		</tr>
	</tfoot>
	<tbody>
		<?php		
		$k = 0;
		$i = 0;
		$n = count( $this->rows );
		$rows = &$this->rows;
		foreach ( $rows as $row) {
			$id = JHTML::_('grid.id', $i, $row->id); 
			$published = JHTML::_('grid.published', $row, $i);	
			$link 	= JRoute::_( 'index.php?option=com_ecboard&view=user&task=edit&cid[]='. $row->id );
		?>
			<tr class="<?php echo "row$k"; ?>">
				<td> <?php echo $i + 1 + $this->pageNav->limitstart; ?> </td>
				<td> <?php echo $id; ?> </td>
				<td> <span class="editlinktip hasTip" title="<?php echo JText::_( 'ECFIRM_EDIT_USER' );?>::<?php echo $this->escape($row->username); ?>">
						<a href="<?php echo $link; ?>"><?php echo $row->username; ?></a>
				</span> </td>
				<td align="left"> <?php echo $row->posts; ?> </td>
				<td align="left"> <?php echo $row->title; ?> </td>
				<td align="left"> <?php echo $row->country; ?> </td>
				<td align="center">										
					<?php
					if ( $row->show_online_status) { echo "<img src='" . $image_yes . "' width='16' height='16' border='0' />"; }
					else { echo "<img src='" . $image_no . "' width='16' height='16' border='0' />"; }	 ?>		
				</td>
				<td align="center">										
					<?php if ( $row->moderator) { echo "<img src='" . $image_yes . "' width='16' height='16' border='0' />"; }
					else { echo "<img src='" . $image_no . "' width='16' height='16' border='0' />"; }	 ?>
				</td>
				<td align="center">										
					<?php if ( $row->email_notification) { echo "<img src='" . $image_yes . "' width='16' height='16' border='0' />"; }
					else { echo "<img src='" . $image_no . "' width='16' height='16' border='0' />"; }	?>
				</td>
				<td align="center">										
					<?php if ( $row->approval_notification) { echo "<img src='" . $image_yes . "' width='16' height='16' border='0' />"; }
					else { echo "<img src='" . $image_no . "' width='16' height='16' border='0' />"; }	 ?>
				</td>
				<td align="center">
					<?php if ( $row->moderated) { echo "<img src='" . $image_yes . "' width='16' height='16' border='0' />"; }
					else { echo "<img src='" . $image_no . "' width='16' height='16' border='0' />"; }	 ?>
				</td>
				<td align="center">
					<?php if ( $row->rookie) { echo "<img src='" . $image_yes . "' width='16' height='16' border='0' />"; }
					else { echo "<img src='" . $image_no . "' width='16' height='16' border='0' />"; }	 ?>
				</td>
				<td align="center">
					<?php if ( $row->trusted) { echo "<img src='" . $image_yes . "' width='16' height='16' border='0' />"; }
					else { echo "<img src='" . $image_no . "' width='16' height='16' border='0' />"; }	 ?>
				</td>
				<td align="center">
					<?php if ( $row->images) { echo "<img src='" . $image_yes . "' width='16' height='16' border='0' />"; }
					else { echo "<img src='" . $image_no . "' width='16' height='16' border='0' />"; }	 ?>
				</td>
				<td align="center"> <?php echo $row->id; ?> </td> 
			</tr>
			<?php $k = 1 - $k; $i++; 
		} ?>
	</tbody>
	</table>
	<input type="hidden" name="option" value="com_ecboard" />
	<input type="hidden" name="controller" value="users" />
	<input type="hidden" name="view" value="users" />
	<input type="hidden" name="boxchecked" value="0" />	
	<input type="hidden" name="task" value="" />
	<?php echo JHTML::_( 'form.token' ); ?>
</form>