<?php
 /** 
 * @version        
 * @package        ecfirm
 * @subpackage    
 * @copyright    Copyright (C) 2011 Kilmeny.net. All rights reserved.
 * @license        GNU General Public License version 2 or later. 
 **/
defined('_JEXEC') or die('Restricted access');
JHTML::_('stylesheet', 'ecboard_nav.css', 'components/com_ecboard/assets/css/');
JHTML::_('stylesheet', 'ecboard_txt.css', 'components/com_ecboard/assets/css/');
JHTML::_('stylesheet', 'ecboard_usr.css', 'components/com_ecboard/assets/css/');
require_once(JPATH_COMPONENT.DS.'classes/user.php'); 
require_once(JPATH_COMPONENT.DS.'classes/helper.php');
$app = JFactory::getApplication();
$user =& JFactory::getUser();
$logUser = new EcfirmboardUser( $user->id);
$EcfirmboardHelper = new EcfirmboardHelper();
$params = JComponentHelper::getParams('com_ecboard'); // get parameters
$_root = JURI::root(); // website root directory
$document =& JFactory::getDocument(); 
$useRssFeeds = $params->get('useRssFeeds', 1); // RSS feed stuff



if ( $useRssFeeds == 1) { 
	$_RssTitle         = JText::_( 'ECFIRMBOARD_RSS_NEW_THREADS' );
	$_RssTitleCategory = JText::_( 'ECFIRMBOARD_RSS_NEW_THREADS_IN' ) . " " . $this->categoryName ; 
	$config =& JFactory::getConfig();
	$_suffix = $config->getValue( 'config.sef_suffix' );
	if ( $_suffix == 0) { // no .html suffix
		$link 		= JRoute::_( 'index.php?option=com_ecboard&format=feed'); }
	else { $link 		= JRoute::_( 'index.php?option=com_ecboard') . '?format=feed'; }
	$attribs 	= array('type' => 'application/rss+xml', 'title' => $_RssTitle); 
	$document->addHeadLink( $link, 'alternate', 'rel', $attribs); 
	if ( $_suffix == 0) { // no .html suffix		
		$linkCategory 	= JRoute::_( 'index.php?option=com_ecboard&view=category&catid=' . $this->categorySlug . '&format=feed' );	}
	else { $linkCategory 	= JRoute::_( 'index.php?option=com_ecboard&view=category&catid=' . $this->categorySlug )  . '?format=feed';	}
	$attribsCategory 	= array('type' => 'application/rss+xml', 'title' => $_RssTitleCategory);
	$document->addHeadLink( $linkCategory, 'alternate', 'rel', $attribsCategory);
} // RSS feed stuff ?>


 
<div class="efeb">

<!-- Javascript functions -->
<script type="text/javascript">
    function callURL(obj) {
        $catid 		= obj.options[obj.selectedIndex].value;
		var length 	= slugsarray.length;
		for(var k=0; k < slugsarray.length; k++) {
			// if selected index found jump to category
			if ( slugsarray[k][0] == $catid) {
         		location.href = slugsarray[k][1];
        	}
		}			
    }
</script>
<!-- Javascript functions -->
<?php /* if ( $this->params->def( 'show_page_title', 1 ) ) : ?>

	<div class="componentheading<?php echo $this->escape($this->params->get('pageclass_sfx')); ?>">
		<?php echo $this->escape($this->params->get('page_title')); ?>
	</div>
<?php endif; */?>



<!-- HTML Box Top -->
<?php $htmlBoxCategoryTop = $params->get('htmlBoxCategoryTop', ''); 
if ( $htmlBoxCategoryTop != "") {
	echo "<div class='efebHtmlBoxCategoryTop'>"; echo $htmlBoxCategoryTop; echo "</div>"; } ?>
<!-- HTML Box Top -->



<?php //include( 'components/com_ecboard/includes/topmenu.php'); ?>



<!-- Category icon, name and description -->
<table width="100%" class="efebnoborder" style="margin-bottom:10px;">
    <tr>
	    <?php echo "<td align='left' valign='middle' class='efebnoborder'>";                	
   		if ( $user->guest) {
   			$registerURL = "index.php?option=com_users&view=registration";
   			$loginURL    = "index.php?option=com_users&view=login"; 
          	echo "<a href='" . JRoute::_( $loginURL) . "' >" . JText::_( 'ECFIRMBOARD_NO_PUBLIC_WRITE_LOGIN' ) . "</a> | ";
           	echo "<a href='" . JRoute::_( $registerURL) . "' >" . JText::_( 'ECFIRMBOARD_NO_PUBLIC_WRITE_REGISTER' ) . "</a>";
   		} else	{
           	echo "<img src='" . $_root . "components/com_ecboard/assets/threads/new.png' style='margin-left: 5px; margin-right: 5px; border:0px;' />";
           	$menuLinkNewTMP = "index.php?option=com_ecboard&view=posting&task=new&catid=".$this->categorySlug;
           	$menuLinkNew = JRoute::_( $menuLinkNewTMP);
            echo "<a href='".$menuLinkNew."'>" . JText::_( 'ECFIRMBOARD_NEW_THREAD' ) . "</a>";
   		}
		echo "</td>"; ?>
        <!-- category name and description -->
        <td align="right" class="efebnoborder">
            <?php //echo $this->categoryName; ?><?php echo $EcfirmboardHelper->getQuickJumpSelectBox( $this->categoryId); ?>
        </td> <!-- category name and description -->
    </tr>
</table>
<!-- Category icon, name and description -->



<?php // Forum specific top banner
 if ( $this->forumBannerTop != "") { 
	echo "<table width='100%' border='0'  class='efebnoborder' style='margin-top:10px;'>"; 
	    echo "<tr>"; 
		echo "<td width='100%' align='center' class='efebnoborder'>"; ?> 
			<script type='text/javascript'> <?php	echo $this->forumBannerTop; ?> </script> 
		<?php echo "</td>"; 
	    echo "</tr>"; 
	echo "</table>"; 
} // Forum specific top banner ?>



<!-- post, reply, login, registration -->
<?php /* if ( $user->guest) { // user is not logged in 
	//echo "<table width='100%' class='efebnoborder' style='margin:20px 0px 20px 0px;'>";
	echo "<table width='100%' class='efebnoborder' style='margin:0px 0px 0px 0px;'>";
    	echo "<tr>";
        	echo "<td width='100%' align='left' valign='middle' class='efebnoborder'>";                	
        		$registerURL = "index.php?option=com_users&view=registration";
        		$loginURL    = "index.php?option=com_users&view=login"; 
            	//echo JText::_( 'ECFIRMBOARD_NO_PUBLIC_WRITE' ); 
            	echo "<a href='" . JRoute::_( $loginURL) . "' >" . JText::_( 'ECFIRMBOARD_NO_PUBLIC_WRITE_LOGIN' ) . "</a>";
	           	echo " | ";//echo JText::_( 'ECFIRMBOARD_OR' );
            	echo "<a href='" . JRoute::_( $registerURL) . "' >" . JText::_( 'ECFIRMBOARD_NO_PUBLIC_WRITE_REGISTER' ) . "</a>";
            echo "</td>";
        echo "</tr>";
    echo "</table>"; 
} else { // user is logged in 
	//echo "<table width='50%' class='efebnoborder' style='margin:20px 0px 20px 0px;'>";
	echo "<table width='50%' class='efebnoborder' style='margin:0px 0px 0px 0px;'>";
    	echo "<tr>";       	
        	echo "<td width='16' align='center' valign='middle' class='efebnoborder'>";
            	echo "<img src='" . $_root . "components/com_ecboard/assets/threads/new.png' style='margin-left: 5px; margin-right: 5px; border:0px;' />";
        	echo "</td>";
        	echo "<td align='left' valign='middle' class='efebnoborder'>";
            	$menuLinkNewTMP = "index.php?option=com_ecboard&view=posting&task=new&catid=".$this->categorySlug;
            	$menuLinkNew = JRoute::_( $menuLinkNewTMP);
            	echo "<a href='".$menuLinkNew."'>" . JText::_( 'ECFIRMBOARD_NEW_THREAD' ) . "</a>";
        	echo "</td>";        
    	echo "</tr>";
	echo "</table>";
} */ ?> <!-- Post, Reply,... Links -->



<!-- Breadcrumb -->
<?php $showBreadcrumbRow = $params->get('breadcrumb', '0');		
if ( $showBreadcrumbRow == "1") { ?> 
	<!-- table class="efebnoborder" style="margin-top: 5px;" -->
	<table class="efebnoborder" style="margin-bottom: 5px;">
	    <tr>
	        <td class="efebnoborder">
	            <?php $menuLinkHome     = JRoute::_( 'index.php?option=com_ecboard');
				$menuText = $app->getMenu()->getActive()->title;	
	            echo "<a href='$menuLinkHome'>" . $menuText . "</a>"; ?>
	        </td>
	        <td class="efebnoborder"> <?php echo "&nbsp;&raquo;&nbsp;"; echo $this->categoryName; ?> </td>
	    </tr>
	</table>
<?php } ?> <!-- Breadcrumb -->



<table width="100%" border="0" cellspacing="0" cellpadding="0" class="efebnoborder"> 
    <tr> 
		<td width="48px"  align="center" class="efebTableHeader"><?php echo JText::_( 'ECFIRMBOARD_REPLIES' ); ?></td>
		<td width="48px"  align="center" class="efebTableHeader"><?php echo JText::_( 'ECFIRMBOARD_TYPE' ); ?></td>
        <td align="center"   class="efebTableHeader"><?php echo JText::_( 'ECFIRMBOARD_TOPIC' ); ?></td>
		<td width="150px" align="center" class="efebTableHeader"><?php echo JText::_( 'ECFIRMBOARD_LAST_POST' ); ?></td> 
		<td width="35px"  align="center" class="efebTableHeader"><?php echo JText::_('ECFIRMBOARD_STICKY')?></td>
    </tr> 



	<?php $rowColor = 1; 
	foreach ( $this->threads as $thread ) : ?>
    	<tr> 
    		<!-- //replies ///////////// -->
			<td align="center" class="efebIndexTableRow<?php echo $rowColor; ?> efebIndexTableRowReplies">	
				<?php echo "<span class='efebIndexTableRowRepliesCounter'>"; echo $thread->counter_replies; echo "</span>"; ?>
			</td><!-- //replies ///////////// -->
			
			<!-- //type ///////////// -->
			<td align="center" class="efebIndexTableRow<?php echo $rowColor; ?> efebIndexTableRowIcon">	
				<?php switch ( $thread->type) {  // check the type of this thread (discussion, question...) 
					case 1: { // discussion
						echo "<img src='" . $_root . "components/com_ecboard/assets/system/discussion.png' alt='Discussion' title='Discussion' />"; break; }
					case 2: { // question
						echo "<img src='" . $_root . "components/com_ecboard/assets/system/question.png' alt='Question' title='Question' />"; break; }
					case 3: { // important
						echo "<img src='" . $_root . "components/com_ecboard/assets/system/important.png' alt='Important' title='Important' />"; break; } 
					default: { // unknown
						echo "<img src='" . $_root . "components/com_ecboard/assets/system/discussion.png' alt='Discussion' title='Discussion' />"; break; }					
				} ?>
			</td> <!-- //type ///////////// -->
			
			<!-- //topic ///////////// -->
			<td align="left" class="efebIndexTableRow<?php echo $rowColor; ?> efebIndexTableRowTopic">
                <?php $_hoverSubject = $thread->subject;
                	$_hoverSubject = str_replace( '\'', '"', $_hoverSubject);
                    $threadLink = JRoute::_('index.php?option=com_ecboard&view=thread&catid='.$this->categorySlug.'&thread='.$thread->slug );
                    echo "<a href='$threadLink' title='".$_hoverSubject."'>".$thread->subject."</a>"; if ( $thread->locked == 1) { // show lock symbol
						echo "<img src='" . $_root . "components/com_ecboard/assets/threads/lock.png' style='margin-left: 5px; border:0px;' />"; }
					echo "<div class='efebIndexTableRowTopicSubtitle'>";
					echo JText::_( 'ECFIRMBOARD_POSTED' ) . " " . $thread->date . " ";
					echo "<b>"; echo $EcfirmboardHelper->getUsernameById( $thread->user_id); echo "</b>";
					// echo " Views: ".$thread->hits;
				echo "</div>"; ?>
			</td> <!-- //topic ///////////// -->
			
			<!-- //last post ///////////// -->
			<td width="150" align="center" class="efebIndexTableRow<?php echo $rowColor; ?> efebIndexTableRowLastPost">
                <table width="100%" cellspacing="0" cellpadding="0" border="0" class="efebnoborder">
                    <tr>
                        <?php /* <td width="32" align="left" class="efebnoborder">
                            <?php $EcfirmboardUser = new EcfirmboardUser( $thread->last_entry_user_id);
					    	echo "<div class='efebCategoryAvatarBox'>";
                                // $lastEntryUserUsername = $EcfirmboardHelper->getUsernameById( $thread->last_entry_user_id);
                                $lastEntryUserUsername = $EcfirmboardUser->getUsername();
                                if ( $EcfirmboardUser->getAvatar() == "") { // display default avatar
                                    echo "<img src='" . $_root . "components/com_ecboard/assets/users/user.png' class='efebCategoryDefaultAvatar'"
                                    	."alt='$lastEntryUserUsername' title='$lastEntryUserUsername' />";
                                } else { // display uploaded avatar
                                    echo "<img src='" . $_root . "images/ecboard/users/".$thread->last_entry_user_id."/small/"
                                    	.$EcfirmboardUser->getAvatar()."' class='efebCategoryAvatar' alt='$lastEntryUserUsername' title='$lastEntryUserUsername' />"; }
                           echo "</div>"; ?>
                        </td> */ ?>
                        <?php $EcfirmboardUser = new EcfirmboardUser( $thread->last_entry_user_id);
	                        $lastEntryUserUsername = $EcfirmboardUser->getUsername(); ?>
                        <td align="left" valign="center" class="efebnoborder" style="padding-left: 5px;">
                            <?php echo $thread->last_entry_date; ?> <br />
                            <?php echo $lastEntryUserUsername; ?>
                        </td>
                        <td width="20" align="right" valign="center" class="efebnoborder">
                            <?php // calculate jump point to last entry
							$_threadListLength 	= $params->get('threadListLength', '20');							
							//$_numberOfPosts 	= $EcfirmboardHelper->getNumberOfPostsByThreadId( $thread->id);
							$_numberOfPosts 	= $thread->counter_replies + 1;							
							$_lastPostId 		= $EcfirmboardHelper->getLastPostIdByThreadId( $thread->id); 
							if ( ( $_numberOfPosts % $_threadListLength) == 0) { $_start = ( $_numberOfPosts / $_threadListLength) - 1; }
							else {		$_start = floor( $_numberOfPosts / $_threadListLength); } 
							$_start = $_start * $_threadListLength;					
							if ( $_start == 0) {  // first page = no limitstart 
								$_lastEntryJumpPoint = "#p" . $_lastPostId;		}
							else { $_lastEntryJumpPoint = "&limitstart=" . $_start ."#p" . $_lastPostId; } 
							$menuLinkLastTMP = "index.php?option=com_ecboard&view=thread&catid=" . $this->categorySlug . "&thread=" . $thread->slug;
							$menuLinkLastTMP .= $_lastEntryJumpPoint;							
            				$menuLinkLast = JRoute::_( $menuLinkLastTMP); 
            				echo "<a href='" . $menuLinkLast . "' title='" . JText::_( 'ECFIRMBOARD_GOTO_LAST_ENTRY' ) . ": " . $thread->subject .  "' rel='nofollow' >";
            				echo "<img src='" . $_root . "components/com_ecboard/assets/system/lastentry.png' style='border:0px;' />";
            				echo "</a>";                                                                                    
                            ?>
                        </td><!-- //last post ///////////// -->
                    </tr>
                </table>
			</td> 

			<!-- sticky -->		
			<td width="32" align="center" class="efebIndexTableRow<?php echo $rowColor; ?>  efebIndexTableRowSticky">
					<?php if ( $thread->sticky == 0) {  // do not show icon 
						echo "&nbsp;"; }
					else { // show sticky icon
						echo "<img src='" . $_root . "components/com_ecboard/assets/threads/sticky.png' style='border:0px;margin:5px;' alt='Sticky' title='Sticky' />";
					} ?>
			</td> <!-- sticky -->		
    	</tr> 

		<?php // toggle row color
		if ( $rowColor == 1) { $rowColor = 2; }
		else { $rowColor = 1; }
	endforeach; ?>
</table>



<!-- Pagination Links -->
<table width="100%" class="pageslinks" style="margin-bottom:0px;">
    <tr>
        <td class="pagination"> <?php echo $this->pagination->getPagesLinks(); ?> </td>
        <td class="pagination"> <?php echo $this->pagination->getPagesCounter(); ?> </td>
    </tr>
</table>
<!-- Pagination Links -->



<!-- Breadcrumb -->
<?php if ( $showBreadcrumbRow == "1") { ?>
	<table class="efebnoborder" style="margin-top: 5px;">
	    <tr>
	        <td class="efebnoborder"> <?php echo "<a href='$menuLinkHome'>" . $menuText . "</a>"; ?> </td>
	        <td class="efebnoborder"> <?php echo "&nbsp;&raquo;&nbsp;"; echo $this->categoryName; ?> </td>
	    </tr>
	</table>
<?php } ?> <!-- Breadcrumb -->



<?php // Forum specific bottom banner 
if ( $this->forumBannerBottom != "") { 
	echo "<table width='100%' border='0' class='efebnoborder' style='margin-top:10px;'>"; 
	    echo "<tr>"; 
	    	echo "<td width='100%' align='center' class='efebnoborder'>"; ?>
					<script type='text/javascript'>
					<?php echo $this->forumBannerBottom; ?> 
					</script>
			<?php echo "</td>"; 
	    echo "</tr>"; 
	echo "</table>"; 
} // Forum specific bottom banner ?>



<?php include( 'components/com_ecboard/includes/share.php'); ?> 



<!-- RSS feed icon -->
<?php $showRssFeedIcon = $params->get('showRssFeedIcon', 1);		
if ( $useRssFeeds == 1 && $showRssFeedIcon == 1) { 
	echo "<div style='margin: 30px 0px 10px 0px;'>"; 
		echo "<img src='" . $_root . "/components/com_ecboard/assets/icons/rss_16.png' style='margin: 0px 10px 0px 5px;' align='top' />";
		echo "<a href='" . $link .  "'>" . $_RssTitle . "</a>";				
	echo "</div>"; 
	echo "<div style='margin: 0px 0px 20px 0px;'>";		
		echo "<img src='" . $_root . "/components/com_ecboard/assets/icons/rss_16.png' style='margin: 0px 10px 0px 5px;' align='top' />";		
		echo "<a href='" . $linkCategory .  "'>" . $_RssTitleCategory . "</a>";						
	echo "</div>"; } ?> <!-- RSS feed icon -->
	
	

<!-- HTML Box Bottom -->
<?php $htmlBoxCategoryBottom = $params->get('htmlBoxCategoryBottom', '');		
if ( $htmlBoxCategoryBottom != "") { echo "<div class='efebHtmlBoxCategoryBottom'>"; echo $htmlBoxCategoryBottom; echo "</div>"; } ?>
<!-- HTML Box Bottom -->



<?php include( 'components/com_ecboard/includes/footer.php'); ?>
</div>