<?php
 /** 
 * @version        
 * @package        ecfirm
 * @subpackage    
 * @copyright    Copyright (C) 2011 Kilmeny.net. All rights reserved.
 * @license        GNU General Public License version 2 or later. 
 **/
defined('_JEXEC') or die('Restricted access');
JHTML::_('stylesheet', 'ecboard_nav.css', 'components/com_ecboard/assets/css/');
JHTML::_('stylesheet', 'ecboard_txt.css', 'components/com_ecboard/assets/css/');
JHTML::_('stylesheet', 'ecboard_usr.css', 'components/com_ecboard/assets/css/');
require_once(JPATH_COMPONENT.DS.'classes/user.php'); 
$user =& JFactory::getUser();
$logUser = new EcfirmboardUser( $user->id);
?>



<div class="efeb">

<?php $document =& JFactory::getDocument(); 
// set page description
if ( JText::_( 'ECFIRMBOARD_INDEX_META_DESCRIPTION') == "") {
	$pageDescription = "";
	// to joomla 1.6
//	$pageDescriptionSuffix = $mainframe->getCfg('sitename');
	$pageDescriptionSuffix = "";
}
// get parameters
$params = JComponentHelper::getParams('com_ecboard');
// website root directory
$_root = JURI::root();
// RSS feed stuff
$useRssFeeds = $params->get('useRssFeeds', 1);		

if ( $useRssFeeds == 1) { 
	$_RssTitle = JText::_( 'ECFIRMBOARD_RSS_NEW_THREADS' ); 
	$config =& JFactory::getConfig();
	$_suffix = $config->getValue( 'config.sef_suffix' );
	if ( $_suffix == 0) { // no .html suffix
		$link 		= JRoute::_( 'index.php?option=com_ecboard&format=feed'); }
	else { $link 		= JRoute::_( 'index.php?option=com_ecboard') . '?format=feed'; }
	$attribs 	= array('type' => 'application/rss+xml', 'title' => $_RssTitle);
	$document->addHeadLink( $link, 'alternate', 'rel', $attribs);
} // RSS feed stuff ?>



<?php /* if ( $this->params->def( 'show_page_title', 1 ) ) : ?>
	<div class="componentheading<?php echo $this->escape($this->params->get('pageclass_sfx')); ?>">
		<?php echo $this->escape($this->params->get('page_title')); ?>
	</div>
<?php endif; */ ?>



<!-- HTML Box Top -->
<?php $htmlBoxIndexTop = $params->get('htmlBoxIndexTop', '');
if ( $htmlBoxIndexTop != "") { echo "<div class='efebHtmlBoxIndexTop'>"; echo $htmlBoxIndexTop; echo "</div>"; } ?>
<!-- HTML Box Top -->



<?php //include( 'components/com_ecboard/includes/topmenu.php'); ?>



<table width="100%" border="0" cellspacing="0" cellpadding="0"> 
	<?php $rowColor = 1;
	foreach ( $this->categories as $category ) : ?>
    <tr> 
			<?php // category or forum image ////////////////
			if ( $category->show_image == 0) { 
				if ( $category->parent_id == 0) {  // category /////////////////	?>
					<td align="center" class="efebContainer">
				<?php	 } else { ?>
					<td align="center">
				<?php } echo "&nbsp;"; ?>
				</td> 
			<?php } else { // forum ////////////// ?>
				<td align="center" class="efebIndexTableRow<?php echo $rowColor; ?> efebIndexViewTableRowCategoryImage">
					<?php if ( $category->image == "") {  // show default category image					
						echo "<img src='" . $_root . "components/com_ecboard/assets/categories/default.png' style='border:0px;margin:5px;' />"; }
					else { echo "<img src='" . $_root . "components/com_ecboard/assets/categories/".$category->image."' style='border:0px;margin:5px;' />"; } ?>
				</td> 
			<?php } // category or forum image //////////////// ?>
			
			
			
			<?php if ( $category->parent_id == 0) {  // container ///////////////			?>
				<td class="efebContainer">
					<br /><?php echo $category->name; ?><br /><br /><?php //echo $category->description; ?>
				</td> 
			<?php } // container ///////////////	
			
			
			
			else { // forum //////////////
				if ( JText::_( 'ECFIRMBOARD_INDEX_META_DESCRIPTION') == "") {
					$pageDescription .= $category->name . ", "; } ?>
				<td class="efebIndexTableRow<?php echo $rowColor; ?> efebIndexViewTableRowCategoryName"> <b>
                    <?php $catLink = JRoute::_('index.php?option=com_ecboard&view=category&catid=' . $this->escape( $category->slug) );                                                
                        echo "<a href='$catLink' title='$category->name'>".$category->name."</a>"; ?> </b> <br />
					<?php echo $category->description; ?> <br />
				</td> 
			<?php } ?>
		<?php if ( $category->parent_id == 0) {  // don't show threads, posts and last post ?>
			<td colspan="3" class="efebContainer">&nbsp;</td> 
		<?php } else { ?>
			<td align="center" class="efebIndexTableRow<?php echo $rowColor; ?> efebIndexViewTableRowThreads">
				<?php echo $category->counter_threads; ?>
			</td> 
			<td align="center" class="efebIndexTableRow<?php echo $rowColor; ?> efebIndexViewTableRowPosts">
				<?php echo $category->counter_posts; ?>
			</td> 
			<td align="center" class="efebIndexTableRow<?php echo $rowColor; ?> efebIndexViewTableRowLastEntry">
				<?php echo $category->last_entry_date.""; echo "<br />";
				echo JText::_( 'ECFIRMBOARD_BY' ) . " ".$category->username ; ?>
			</td> 
		<?php } // forum //////////////  ?>
    </tr> 
    
    
    <?php // forum header ///////////////// ?>
	<?php if ( $category->parent_id == 0) {  // don't show threads, posts and last post ?>
    	<tr> 
			<td width="53px" align="center" class="efebTableHeader"> &nbsp; </td> 
        	<td align="left" class="efebTableHeader"><?php echo JText::_( 'ECFIRMBOARD_FORUM' ); ?></td> 
			<td width="70px" align="center" class="efebTableHeader"><?php echo JText::_( 'ECFIRMBOARD_THREADS' ); ?></td> 
			<td width="70px" align="center" class="efebTableHeader"><?php echo JText::_( 'ECFIRMBOARD_POSTS' ); ?></td> 
			<td width="150px" align="center" class="efebTableHeader"><?php echo JText::_( 'ECFIRMBOARD_LAST_ENTRY' ); ?></td> 
    	</tr> 
	<?php } // forum header ///////////////// ?>
	<?php // toggle row color
	if ( $rowColor == 1) { $rowColor = 2; }
	else { $rowColor = 1; }
	endforeach; 
	
	
	
	// set page description
	if ( JText::_( 'ECFIRMBOARD_INDEX_META_DESCRIPTION') == "") { $document->setDescription( $pageDescription . $pageDescriptionSuffix); 	} ?>
</table>



<?php include( 'components/com_ecboard/includes/share.php'); ?>



<!-- RSS feed icon -->
<?php $showRssFeedIcon = $params->get('showRssFeedIcon', 1);		
if ( $useRssFeeds == 1 && $showRssFeedIcon == 1) { 
	echo "<div style='margin: 40px 0px 30px 0px;'>"; 
		echo "<img src='" . $_root . "/components/com_ecboard/assets/icons/rss_16.png' style='margin: 0px 10px 0px 5px;' align='top' />"; 
		echo "<a href='" . $link .  "'>" . $_RssTitle . "</a>";				
	echo "</div>"; 
} ?> <!-- RSS feed icon -->



<!-- HTML Box Bottom -->
<?php $htmlBoxIndexBottom = $params->get('htmlBoxIndexBottom', '');		
if ( $htmlBoxIndexBottom != "") { echo "<div class='efebHtmlBoxIndexBottom'>"; echo $htmlBoxIndexBottom; echo "</div>"; } ?>
<!-- HTML Box Bottom -->



<?php include( 'components/com_ecboard/includes/footer.php'); ?>
</div>