<?php
 /** 
 * @version        
 * @package        ecfirm
 * @subpackage    
 * @copyright    Copyright (C) 2011 Kilmeny.net. All rights reserved.
 * @license        GNU General Public License version 2 or later. 
 **/

defined('_JEXEC') or die('Restricted access');
JHTML::_('stylesheet', 'ecboard_nav.css', 'components/com_ecboard/assets/css/');
JHTML::_('stylesheet', 'ecboard_txt.css', 'components/com_ecboard/assets/css/');
JHTML::_('stylesheet', 'ecboard_usr.css', 'components/com_ecboard/assets/css/');
require_once(JPATH_COMPONENT.DS.'classes/user.php');
require_once(JPATH_COMPONENT.DS.'classes/helper.php');
$user =& JFactory::getUser();
$logUser = new EcfirmboardUser( $user->id);
$EcfirmboardHelper = new EcfirmboardHelper();
$app = JFactory::getApplication();
// get parameters
$params = JComponentHelper::getParams('com_ecboard');
$replyListLength = $params->get('replyListLength', '0');
$_useFlickr 	 = $params->get( 'useFlickr', '0');  // 0 no, 1 yes
$_useYouTube 	 = $params->get( 'useYouTube', '0');  // 0 no, 1 yes
// website root directory
$_root = JURI::root();
?>



<div class="efeb">

<!-- Javascript functions -->
<script type="text/javascript">
    function callURL(obj) {
        $catid 		= obj.options[obj.selectedIndex].value;
		var length 	= slugsarray.length;
		for(var k=0; k < slugsarray.length; k++) {
			// if selected index found jump to category
			if ( slugsarray[k][0] == $catid) {
         		location.href = slugsarray[k][1];
        	}
		}			
    }
</script>
<!-- Javascript functions -->



<?php /* if ( $this->params->def( 'show_page_title', 1 ) ) : ?>
	<div class="componentheading<?php echo $this->escape($this->params->get('pageclass_sfx')); ?>">
		<?php echo $this->escape($this->params->get('page_title')); ?>
	</div>
<?php endif; */ ?>



<!-- HTML Box Top -->
<?php $htmlBoxPostingTop = $params->get('htmlBoxPostingTop', '');
if ( $htmlBoxPostingTop != "") {
	echo "<div class='efebHtmlBoxPostingTop'>".$htmlBoxPostingTop."</div>";
} ?> <!-- HTML Box Top -->



<?php //include( 'components/com_ecboard/includes/topmenu.php'); ?>



<?php echo "<h3>"; echo $this->headline; echo "</h3>"; ?>



<!-- Breadcrumb -->
<?php $showBreadcrumbRow = $params->get('breadcrumb', '0');		
if ( $showBreadcrumbRow == "1") { ?>
	<table class="efebnoborder" style="margin-top: 5px;">
	    <tr>
	        <td class="efebnoborder">
	            <?php $menuLinkHome     = JRoute::_( 'index.php?option=com_ecboard');
				$menuText = $app->getMenu()->getActive()->title;	
	            echo "<a href='$menuLinkHome'>" . $menuText . "</a>"; ?>
	        </td>
	        <td class="efebnoborder">
	            <?php $menuLinkCategoryTMP = "index.php?option=com_ecboard&view=category&catid=".$this->categorySlug;
	            $menuLinkCategory = JRoute::_( $menuLinkCategoryTMP);
	            echo "&nbsp;&raquo;&nbsp;";
	            echo "<a href='$menuLinkCategory'>".$this->categoryName."</a>"; ?>
	        </td>
	        <td class="efebnoborder">
	            <?php
	            if ( $this->subject != "") { echo "&nbsp;&raquo;&nbsp;";
	            	if ( $this->task == "new") { echo $this->headline; }
	            	else {echo $this->subject; }	            	
	            } ?>
	        </td>
	    </tr>
	</table>
<?php } ?>
<!-- Breadcrumb -->



<?php 
    echo "<form action='' method='post' name='postform' id='postform' enctype='multipart/form-data'>";
    	echo "<table cellspacing='1' cellpadding='0' width='100%' class='efebnoborder'>";
    		echo "<tr>";    		
    			echo "<td class='efebTextLine' style='padding: 5px;' >";
    				//echo "<div class='efebSubjectHeader'>" . JText::_( 'ECFIRMBOARD_SUBJECT' ) . "&nbsp; </div>";
					if ( $this->task == "new") { // new posting
            			echo "<div class='efebSubject'>"; echo "<input type='text' name='postSubject' id='postSubject' size='60' maxlength='80'>"; echo "</div>";
            			echo "<div class='efebSubjectFooter'>&nbsp;" . JText::_( 'ECFIRMBOARD_MIN_5_CHARS' ) . "</div> ";
					} else {
						$_reSubject = "Re: ".$this->subject;
            			echo "<div class='efebSubject'>".$_reSubject."</div>";
						$_reSubject = str_replace( '"', "'", $_reSubject); ?>
            			<input type="hidden" name="postSubject" id="postSubject" value="<?php echo $_reSubject; ?>">	
					<?php }
    			echo "</td>";
    		echo "</tr>";
    		
    		
    		
    		echo "<tr>";
    			echo "<td align='left' valign='top' class='efebTextLine' style='padding: 5px;' >";
    				//echo "<div class='efebTextHeader'>" . JText::_( 'ECFIRMBOARD_TEXT' ) . "</div> ";
   					echo "<div class='efebText'>";			    			
   						echo "<textarea name='postText' cols='60' rows='15' wrap='VIRTUAL' id='postText'>";
							if ( $this->task == "quote") { echo "[quote]" . $this->messageText . "[/quote]"; }
							if ( $this->task == "edit") { echo $this->messageText; }
    					echo "</textarea>";
    				echo "</div>";
            		//echo "<div class='efebTextFooter'>" . JText::_( 'ECFIRMBOARD_MIN_5_CHARS' ) . "</div> ";
            		
            		
            		
					if ( $EcfirmboardHelper->isPermittedForImageAttachmentsById( $user->id) ) {
						// image attachments (if configured)
		    			// get # of images from parameters
						$params = JComponentHelper::getParams('com_ecboard');
						$images = $params->get('images', '3'); // 3 default		
						if ( $this->task == "quote") {
							$this->image1 = "";
							$this->image1_description = "";
							$this->image2 = "";
							$this->image2_description = "";
							$this->image3 = "";
							$this->image3_description = "";
							$this->image4 = "";
							$this->image4_description = "";
							$this->image5 = "";
							$this->image5_description = "";	
						} 
						if ( $images > 0) { // image
				    		//echo "<div class='efebImageHeader efebFirstImageHeader' >Image 1:</div> "; // image show/delete								
					    	if ( $this->image1 != "") { 
	   							echo "<div>"; echo "<img src='" . $_root . "images/ecboard/posts/".$this->thread."/" . $this->id . "/small/" . $this->image1 
						        	. "' alt='" . $this->subject . "' align='top' class='efebAttachmentImageEdit' />"; 
		        				echo "<input type='checkbox' name='cb_image1' class='efebAttachmentCheckboxEdit' value='delete'> " . JText::_( 'delete' );
	   							echo "</div>";
					    	}			    
							// image upload			   							
	            			echo "<div class='efebImage'>";
								echo "<input type='file' name='image1' id='image1' value='' size='50' maxlength='250' />";
	            			echo "</div>";
	            			echo "<div class='efebImageFooter'>Select image to upload (JPG or PNG) (optional)</div> ";
	            			// Description
				    		/* echo "<div class='efebImageHeader'>Image 1 Description:</div> ";
	            			echo "<div class='efebImageDescription'>";
								echo "<input type='text' name='image1_description' id='image1_description' size='50' maxlength='80' value='" 
									. $this->image1_description . "' >";
	            			echo "</div>";
	            			echo "<div class='efebImageFooter'>Description for image 1. Will be used as ALT tag (optional)</div> "; */
						}
						if ( $images > 1) { // image
				    		//echo "<div class='efebImageHeader efebFirstImageHeader'>Image 2:</div> "; // image show/delete								
					    	if ( $this->image2 != "") { 
	   							echo "<div>";
						        	echo "<img src='" . $_root . "images/ecboard/posts/".$this->thread."/" . $this->id . "/small/" . $this->image2 . "' alt='" 
						        		. $this->subject . "' align='top' class='efebAttachmentImageEdit' />";
		        				echo "<input type='checkbox' name='cb_image2' class='efebAttachmentCheckboxEdit' value='delete'> " . JText::_( 'delete' );
	   							echo "</div>";
					    	}			    
							// image upload			   										   							
	            			echo "<div class='efebImage'>";
								echo "<input type='file' name='image2' id='image2' value='' size='50' maxlength='250' />";
	            			echo "</div>";
	            			echo "<div class='efebImageFooter'>Select image to upload (JPG or PNG) (optional)</div> ";
	            			// Description
				    		/* echo "<div class='efebImageHeader'>Image 2 Description:</div> ";
	            			echo "<div class='efebImageDescription'>";
								echo "<input type='text' name='image2_description' id='image2_description' size='50' maxlength='80' value='" 
									. $this->image2_description . "'>";
	            			echo "</div>";
	            			echo "<div class='efebImageFooter'>Description for image 2. Will be used as ALT tag (optional)</div> "; */
						}						
						if ( $images > 2) { // image
				    		//echo "<div class='efebImageHeader efebFirstImageHeader'>Image 3:</div> "; // image show/delete								
					    	if ( $this->image3 != "") { 
	   							echo "<div>";
						        	echo "<img src='" . $_root . "images/ecboard/posts/".$this->thread."/" . $this->id . "/small/" . $this->image3 
						        		. "' alt='" . $this->subject . "' align='top' class='efebAttachmentImageEdit' />";
		        				echo "<input type='checkbox' name='cb_image3' class='efebAttachmentCheckboxEdit' value='delete'> " . JText::_( 'delete' );
	   							echo "</div>";
					    	}			    
							// image upload			   										   							
	            			echo "<div class='efebImage'>";
								echo "<input type='file' name='image3' id='image3' value='' size='50' maxlength='250' />";
	            			echo "</div>";
	            			echo "<div class='efebImageFooter'>Select image to upload (JPG or PNG) (optional)</div> ";
	            			// Description
				    		/* echo "<div class='efebImageHeader'>Image 3 Description:</div> ";
	            			echo "<div class='efebImageDescription'>";
								echo "<input type='text' name='image3_description' id='image3_description' size='50' maxlength='80' value='" 
									. $this->image3_description . "' >";
	            			echo "</div>";
	            			echo "<div class='efebImageFooter'>Description for image 3. Will be used as ALT tag (optional)</div> "; */
						}
						if ( $images > 3) { // image
				    		//echo "<div class='efebImageHeader efebFirstImageHeader'>Image 4:</div> "; // image show/delete								
					    	if ( $this->image4 != "") { 
	   							echo "<div>";
						        	echo "<img src='" . $_root . "images/ecboard/posts/".$this->thread."/" . $this->id . "/small/" . $this->image4 . "' alt='" 
						        		. $this->subject . "' align='top' class='efebAttachmentImageEdit' />";
		        				echo "<input type='checkbox' name='cb_image4' class='efebAttachmentCheckboxEdit' value='delete'> " . JText::_( 'delete' );
	   							echo "</div>";
					    	}			    
							// image upload			   							
	            			echo "<div class='efebImage'>";
								echo "<input type='file' name='image4' id='image4' value='' size='50' maxlength='250' />";
	            			echo "</div>";
	            			echo "<div class='efebImageFooter'>Select image to upload (JPG or PNG) (optional)</div> ";
	            			// Description
				    		/* echo "<div class='efebImageHeader'>Image 4 Description:</div> ";
	            			echo "<div class='efebImageDescription'>";
								echo "<input type='text' name='image4_description' id='image4_description' size='50' maxlength='80' value='" . $this->image4_description . "'>";
	            			echo "</div>";
	            			echo "<div class='efebImageFooter'>Description for image 4. Will be used as ALT tag (optional)</div> "; */ 
						}
						if ( $images > 4) { // image
				    		//echo "<div class='efebImageHeader efebFirstImageHeader'>Image 5:</div> "; // image show/delete								
					    	if ( $this->image5 != "") { 
	   							echo "<div>";
						        	echo "<img src='" . $_root . "images/ecboard/posts/".$this->thread."/" . $this->id . "/small/" . $this->image5 . "' alt='" 
						        		. $this->subject . "' align='top' class='efebAttachmentImageEdit' />";
		        				echo "<input type='checkbox' name='cb_image5' class='efebAttachmentCheckboxEdit' value='delete'> " . JText::_( 'delete' );
	   							echo "</div>";
					    	}			    
							// image upload			   							
	            			echo "<div class='efebImage'>";
								echo "<input type='file' name='image5' id='image5' value='' size='50' maxlength='250' />";
	            			echo "</div>";
	            			echo "<div class='efebImageFooter'>Select image to upload (JPG or PNG) (optional)</div>";
	            			// Description
				    		/* echo "<div class='efebImageHeader'>Image 5 Description:</div> ";
	            			echo "<div class='efebImageDescription'>";
								echo "<input type='text' name='image5_description' id='image5_description' size='50' maxlength='80' value='" 
									. $this->image5_description . "' >";
	            			echo "</div>";
	            			echo "<div class='efebImageFooter'>Description for image 5. Will be used as ALT tag (optional)</div> "; */
						}
					}
            		echo "<div class='efebTextButton'>";
    					switch ( $this->task) {
    						case "edit": { echo "<input type='hidden' name='dbmode' value='update'>"; break; }
							default: { echo "<input type='hidden' name='dbmode' value='insert'>"; break; }					
						}
						echo "<input type='hidden' name='task' value='save'>";  			
						echo "<input class='efebButton' type='submit' name='submit' value='&nbsp;" . JText::_( 'ECFIRMBOARD_SAVE' ) ."&nbsp;'>";
					echo "</div> ";
    			echo "</td>";
    		echo "</tr>";
    	echo "</table>";
    echo "</form>";
    // display recent x posts if task = reply or quote
    if ( $this->task == "reply" || $this->task == "quote" ) {
        if ( $replyListLength > 0) {
            echo "<div class='efebPostRecentX'>";
                echo "<div class='efebPostRecentHeader'>";
                    echo JText::_( 'ECFIRMBOARD_REPLY_RECENT1' );
                    echo " " . $replyListLength . " ";
                    echo JText::_( 'ECFIRMBOARD_REPLY_RECENT2' );
                echo "</div>";
                echo "<div class='efebPostRecent'>";
                    echo $EcfirmboardHelper->getReplyRecentListByThreadId( $this->thread, $replyListLength);
                echo "</div>";
            echo "</div>";
        }
    }
?>



<?php /*
<div class="efebPostHelp">
    <div class="efebTextFormatHeader"> <?php echo JText::_( 'ECFIRMBOARD_FORMAT_YOUR_TEXT' ); ?>: </div>
    <div class="efebTextFormat">
		<table cellspacing="0px" cellpadding="10px" width="100%" class="efebnoborder">
			<tr>
				<td class="efebnoborder"> <b><?php echo JText::_( 'ECFIRMBOARD_FORMAT_BOLD' ); ?></b> <br /> [b]bold[/b] <br /> <br /> </td>
				<td class="efebnoborder"> <i><?php echo JText::_( 'ECFIRMBOARD_FORMAT_ITALICS' ); ?></i> <br /> [i]italics[/i] <br /> <br /> </td>
				<td class="efebnoborder"> <u><?php echo JText::_( 'ECFIRMBOARD_FORMAT_UNDERLINE' ); ?></u> <br /> [u]underline[/u] <br /> <br /> </td>
			</tr>
			<tr>
				<td class="efebnoborder"> <s><?php echo JText::_( 'ECFIRMBOARD_FORMAT_STRIKE_THROUGH' ); ?></s> <br /> [s]strikethrough[/s] <br /> <br /> </td>
				<td class="efebnoborder"> <big><?php echo JText::_( 'ECFIRMBOARD_FORMAT_BIG' ); ?></big> <br /> [big]big[/big] <br /> <br /> </td>
				<td class="efebnoborder"> <small><?php echo JText::_( 'ECFIRMBOARD_FORMAT_SMALL' ); ?></small> <br /> [small]small[/small] <br /> <br /> </td>
			</tr>
			<tr>
				<td valign="top" class="efebnoborder">
					<?php echo JText::_( 'ECFIRMBOARD_FORMAT_UNORDERED_LIST' ); ?>
					<br /> [ul] <br /> [li]first[/li] <br /> [li]second[/li] <br /> [/ul] <br /> <br />
				</td>
				<td valign="top" class="efebnoborder">
					<?php echo JText::_( 'ECFIRMBOARD_FORMAT_ORDERED_LIST' ); ?>
					<br /> [ol] <br /> [li]first[/li] <br /> [li]second[/li] <br /> [/ol] <br /> <br />
				</td>
				<td valign="top" class="efebnoborder">
					<?php echo JText::_( 'ECFIRMBOARD_FORMAT_LINK' ); ?> <br />
					[url]http://ecfirm.net[/url] <br /> [url=http://ecfirm.net]E-Commerce Firm[/url] <br /> <br />
				</td>
			</tr>
            <tr>
                <td valign="top" class="efebnoborder">
                    <?php echo JText::_( 'ECFIRMBOARD_FORMAT_QUOTE' ); ?> <br />
                   [quote]quoted text[/quote] <br /> <br />
                </td>
                <td valign="top" class="efebnoborder">
                	<?php if ( $_useFlickr == 1) {                
                    	echo JText::_( 'ECFIRMBOARD_FLICKR_PHOTO' );
                   		echo "<br />";
                   		echo "[flickr=PHOTOID]";
                   	} else {
                   		echo "&nbsp;";                   	
                   	} ?> <br /> <br />
                </td>
                <td valign="top" class="efebnoborder">
                	<?php if ( $_useYouTube == 1) {                
                    	echo JText::_( 'ECFIRMBOARD_YOUTUBE_VIDEO' );
                   		echo "<br />";
                   		echo "[youtube=VIDEOID]";
                   	} else { echo "&nbsp;"; }
                   	?> <br /> <br />
                </td>
            </tr>
			<tr>
				<td colspan="3" class="efebnoborder"> &nbsp; </td>
			</tr>
			<tr>
				<td class="efebnoborder">
					<?php echo "<img src='" . $_root . "components/com_ecboard/assets/emoticons/smile.gif' />"; ?> &nbsp;&nbsp; :-) <br /> <br />
				</td>
				<td class="efebnoborder">
					<?php echo "<img src='" . $_root . "components/com_ecboard/assets/emoticons/wink.gif' />"; ?> &nbsp;&nbsp; ;-) <br /> <br />
				</td>
				<td class="efebnoborder">
					<?php echo "<img src='" . $_root . "components/com_ecboard/assets/emoticons/sad.gif' />"; ?> &nbsp;&nbsp; :-( <br /> <br />
				</td>
			</tr>
			<tr>
				<td class="efebnoborder">
					<?php echo "<img src='" . $_root . "components/com_ecboard/assets/emoticons/laugh.gif' />"; ?> &nbsp;&nbsp; :-D <br /> <br />
				</td>
				<td class="efebnoborder">
					<?php echo "<img src='" . $_root . "components/com_ecboard/assets/emoticons/kiss.gif' />"; ?> &nbsp;&nbsp; ;-* <br /> <br />
				</td>
				<td class="efebnoborder">
					<?php echo "<img src='" . $_root . "components/com_ecboard/assets/emoticons/cool.gif' />"; ?> &nbsp;&nbsp; 8-) <br /> <br />
				</td>
			</tr>
			<tr>
				<td class="efebnoborder">
					<?php echo "<img src='" . $_root . "components/com_ecboard/assets/emoticons/thumbup.gif' />"; ?> &nbsp;&nbsp; (Y) <br /> <br />
				</td>
				<td class="efebnoborder">
					<?php echo "<img src='" . $_root . "components/com_ecboard/assets/emoticons/thumbdown.gif' />"; ?> &nbsp;&nbsp; (N) <br /> <br />
				</td>
				<td class="efebnoborder">
					<?php echo "<img src='" . $_root . "components/com_ecboard/assets/emoticons/tongue.gif' />"; ?> &nbsp;&nbsp; :-P <br /> <br />
				</td>
			</tr>
			<tr>
				<td class="efebnoborder">
					<?php echo "<img src='" . $_root . "components/com_ecboard/assets/emoticons/crying.gif' />"; ?> &nbsp;&nbsp; :'( <br /> <br />
				</td>
				<td class="efebnoborder">
					<?php echo "<img src='" . $_root . "components/com_ecboard/assets/emoticons/innocent.gif' />"; ?> &nbsp;&nbsp; O:-) <br /> <br />
				</td>
				<td class="efebnoborder">
					<?php echo "<img src='" . $_root . "components/com_ecboard/assets/emoticons/devil.gif' />"; ?> &nbsp;&nbsp; >:-) <br /> <br />
				</td>
			</tr>
		</table>
    </div>
</div>
*/ ?>

<!-- HTML Box Bottom -->
<?php $htmlBoxPostingBottom = $params->get('htmlBoxPostingBottom', '');		
if ( $htmlBoxPostingBottom != "") { echo "<div class='efebHtmlBoxPostingBottom'>"; echo $htmlBoxPostingBottom; echo "</div>"; } ?>
<!-- HTML Box Bottom -->

<?php include( 'components/com_ecboard/includes/footer.php'); ?>
</div>


