<?php
 /** 
 * @version        
 * @package        ecfirm
 * @subpackage    
 * @copyright    Copyright (C) 2011 Kilmeny.net. All rights reserved.
 * @license        GNU General Public License version 2 or later. 
 **/
 
defined('_JEXEC') or die('Restricted access');
jimport('joomla.application.component.view');

class EcboardViewDashboard extends JView {
	function display($tpl = null) {
		$model = &$this->getModel();
		$latestEntries = $model->getLatestEntries();
		$this->assignRef('latestEntries',$latestEntries);
		$numOfEntries = $model->countEntries();
		$this->assignRef('numOfItems',$numOfItems);
		$numOfCategories = $model->countCategories();
		$this->assignRef('numOfCategories',$numOfCategories);
		$user = & JFactory::getUser();
		JToolBarHelper::title( "Ecboard - " . JText::_('ECFIRM_DASHBOARD'), "ecboard.png");		
		JToolBarHelper::preferences('com_ecboard', '600', '800');
		JSubMenuHelper::addEntry(JText::_('ECFIRM_DASHBOARD'), 'index.php?option=com_ecboard', true);
		JSubMenuHelper::addEntry(JText::_('ECFIRM_FORUMS'), 'index.php?option=com_ecboard&view=forums');
		JSubMenuHelper::addEntry(JText::_('ECFIRM_POSTS'), 'index.php?option=com_ecboard&view=posts');
		JSubMenuHelper::addEntry(JText::_('ECFIRM_USERS'), 'index.php?option=com_ecboard&view=users');
		require_once ( JPATH_COMPONENT.DS.'models'.DS.'posts.php');
		$postsModel = new EcboardModelPosts;
		$latestPosts = $postsModel->latestPosts( 10);  // get 10 latest posts		
		$this->assignRef( 'latestPosts', $latestPosts);
		parent::display($tpl);
	}
}