<?php
 /** 
 * @version        
 * @package        ecfirm
 * @subpackage    
 * @copyright    Copyright (C) 2011 Kilmeny.net. All rights reserved.
 * @license        GNU General Public License version 2 or later. 
 **/
 
defined('_JEXEC') or die('Restricted access');
jimport('joomla.application.component.view');

class EcboardViewPosts extends JView {
	function display($tpl = null) {
		$option = "com_ecboard";
		$app = JFactory::getApplication();		
		JHTML::_('behavior.tooltip');
		$user 		= & JFactory::getUser();
		$db  		= & JFactory::getDBO();
		$search 			= $app->getUserStateFromRequest( $option.'.posts.search', 'search', '', 'string');
		$search 			= $db->getEscaped( trim( JString::strtolower( $search )));
		$filter_state		= $app->getUserStateFromRequest( $option.'.posts.filter_state', 'filter_state', '*', 'word');
		$filter_order		= $app->getUserStateFromRequest( $option.'.posts.filter_order', 'filter_order', 	'ordering', 'cmd' );
		$filter_order_Dir	= $app->getUserStateFromRequest( $option.'.posts.filter_order_Dir', 'filter_order_Dir', '', 'word' );
		$rows      	= & $this->get( 'Data');
		$pageNav 	= & $this->get( 'Pagination' );
		$lists['search']	= $search;
		$lists['state']		= JHTML::_('grid.state', $filter_state );
		$lists['order_Dir'] = $filter_order_Dir;
		$lists['order'] 	= $filter_order;
		$this->assignRef('lists'      	, $lists);
		$this->assignRef('user'			, $user);
		$this->assignRef('rows'      	, $rows);
		$this->assignRef('pageNav' 		, $pageNav);
		JToolBarHelper::title( "Ecboard - " . JText::_('ECFIRM_POSTS'), "ecboard.png");	
		JToolBarHelper::publishList();
		JToolBarHelper::unpublishList();
		JToolBarHelper::divider();
		JToolBarHelper::editList();
		JToolBarHelper::divider();
		JToolBarHelper::preferences('com_ecboard', '600', '800');
		JSubMenuHelper::addEntry(JText::_('ECFIRM_DASHBOARD'), 'index.php?option=com_ecboard');
		JSubMenuHelper::addEntry(JText::_('ECFIRM_FORUMS'), 'index.php?option=com_ecboard&view=forums');
		JSubMenuHelper::addEntry(JText::_('ECFIRM_POSTS'), 'index.php?option=com_ecboard&view=posts', true);
		JSubMenuHelper::addEntry(JText::_('ECFIRM_USERS'), 'index.php?option=com_ecboard&view=users');
		parent::display($tpl);
	}
}