<?php
 /** 
 * @version        
 * @package        ecfirm
 * @subpackage    
 * @copyright    Copyright (C) 2011 Kilmeny.net. All rights reserved.
 * @license        GNU General Public License version 2 or later. 
 **/
 
defined('_JEXEC') or die( 'Restricted access' );
jimport( 'joomla.application.component.view');

/** * Category View */ 
class EcboardViewCategory extends JView { 
	/** * Renders the view * */ 
    function display() { 
		global $mainframe; 
		$document =& JFactory::getDocument(); 
		$app 		= JFactory::getApplication();
		$pathway	= &$app->getPathway(); 
		$threads                	=& $this->get('Threads');
		$pagination             	=& $this->get('Pagination'); 
        $categoryId             	=& $this->get('CategoryId');
        $categoryName           	=& $this->get('CategoryName');
		$categoryDescription    	=& $this->get('CategoryDescription');
		$categoryImage          	=& $this->get('CategoryImage');
        $categorySlug           	=& $this->get('CategorySlug'); 
        $forumBannerTop         	=& $this->get('ForumBannerTop');
        $forumBannerBottom     	 	=& $this->get('ForumBannerBottom'); 
        $categoryMetaTitle      	=& $this->get('CategoryMetaTitle');
        $categoryMetaDescription	=& $this->get('CategoryMetaDescription');
        $categoryMetaKeywords      	=& $this->get('CategoryMetaKeywords');
		// get parameters
		$params = &$app->getParams();
		$menus	= &JSite::getMenu();
		$menu	= $menus->getActive();
			
		// Set Meta Tags		
		// 1. Meta Title
		if ( $categoryMetaTitle == "") { $document->setTitle( $categoryName); }
		else { // use the meta title configured for this forum
			$document->setTitle( $categoryMetaTitle); }

		// 2. Meta Description
		if ( $categoryMetaDescription == "") { $document->setDescription( $categoryDescription); }
		else { // use the meta description configured for this forum
			$document->setDescription( $categoryMetaDescription); }

		// 3. Meta Keywords
		if ( $categoryMetaKeywords == "") { // $document->setMetaData( "keywords", "");
		} else { // use the meta keywords configured for this forum
			$document->setMetaData( "keywords", $categoryMetaKeywords); }

		//set breadcrumbs
		if( is_object($menu) && $menu->query['view'] != 'category') { $pathway->addItem( $categoryName, ''); }
        
		$this->assignRef('threads',	$threads);
		$this->assignRef('pagination', $pagination);
		$this->assignRef('categoryId', $categoryId);
		$this->assignRef('categoryName', $categoryName);
		$this->assignRef('categoryDescription', $categoryDescription);
		$this->assignRef('categoryImage', $categoryImage);
		$this->assignRef('categorySlug', $categorySlug);
		$this->assignRef('forumBannerTop', $forumBannerTop);
		$this->assignRef('forumBannerBottom', $forumBannerBottom);		
		$this->assignRef('params',		$params);
        // display the view 
        parent::display(); 
    }
}