<?php
 /** 
 * @version        
 * @package        ecfirm
 * @subpackage    
 * @copyright    Copyright (C) 2011 Kilmeny.net. All rights reserved.
 * @license        GNU General Public License version 2 or later. 
 **/

defined('_JEXEC') or die('Restricted access');
JHTML::_('stylesheet', 'ecboard_nav.css', 'components/com_ecboard/assets/css/');
JHTML::_('stylesheet', 'ecboard_txt.css', 'components/com_ecboard/assets/css/');
JHTML::_('stylesheet', 'ecboard_usr.css', 'components/com_ecboard/assets/css/');

$user =& JFactory::getUser();
$EcfirmboardUser = new EcfirmboardUser( $user->id);
$app = JFactory::getApplication();

// get parameters
$params = JComponentHelper::getParams('com_ecboard');
// website root directory
$_root = JURI::root();
?>

<div class="efeb>
<?php if ( $this->params->def( 'show_page_title', 1 ) ) : ?>
	<div class="componentheading<?php echo $this->escape($this->params->get('pageclass_sfx')); ?>">
		<?php echo $this->escape($this->params->get('page_title')); ?>
	</div>
<?php endif; ?>

<!-- HTML Box Top -->
<?php $htmlBoxProfileTop = $params->get('htmlBoxProfileTop', '');
if ( $htmlBoxProfileTop != "") { echo "<div class='efebHtmlBoxProfileTop'>"; echo $htmlBoxProfileTop; echo "</div>"; } ?>
<!-- HTML Box Top -->

<?php include( 'components/com_ecboard/includes/topmenu.php'); ?>

<?php echo "<h3>"; echo $this->headline; echo "</h3>"; ?>

<!-- Breadcrumb -->
<?php $showBreadcrumbRow = $params->get('breadcrumb', '0');		
if ( $showBreadcrumbRow == "1") { ?>
	<table class="efebnoborder" style="margin-top: 5px;">
	    <tr>
	        <td class="efebnoborder">
	            <?php $menuLinkHome 	= JRoute::_( 'index.php?option=com_ecboard');
				$menuText 		= $app->getMenu()->getActive()->title;	
	            echo "<a href='$menuLinkHome'>" . $menuText . "</a>"; ?>
	        </td>
	        <td class="efebnoborder">
	            <?php echo "&nbsp;&raquo;&nbsp;"; echo JText::_( "ECFIRMBOARD_PROFILE", true ); ?>
	        </td>
	    </tr>
	</table>
<?php } ?>
<!-- Breadcrumb -->

<?php echo "<br />"; 
echo "<div class='efebProfileContent'>";
echo "<form action='' method='post' name='postform' id='postform' enctype='multipart/form-data'>";
	echo "<table cellspacing='0' cellpadding='0' width='100%' border='0' class='efebnoborder'>";
		echo "<tr>";
			echo "<td align='left' valign='top' width='100%' class='efebnoborder' style='padding: 10px;' colspan='2'>";
				echo "<div class='efebProfileUsername'>"; echo $user->username; echo "</div>";
				echo "<div class='efebProfileName'>"; echo "&nbsp;&nbsp;&nbsp;(".$user->name.")"; echo "</div>"; echo "<br />";
			echo "</td>";    
		echo "</tr>";
		echo "<tr>";
			// left column			
			echo "<td align='left' valign='top' width='50%' class='efebnoborder' style='padding: 10px;' >";
				echo "<div class='efebProfileLocationBox'>";
					echo "<div class='efebProfileLocationHeader'>";
						echo "<div class='efebProfileHeader'>"; echo JText::_( 'ECFIRMBOARD_LOCATION' ); echo "</div>";
				    echo "</div>";
					echo "<div class='efebProfileLocationRow'>";
						echo "<div class='efebProfileLocationLabel'>"; echo JText::_( 'ECFIRMBOARD_ZIPCODE' ) . ": "; echo "</div>";
						echo "<div class='efebProfileLocationValue'>";						
	            				echo "<input type='text' name='zipcode' id='zipcode' size='5' maxlength='10' value='".$EcfirmboardUser->getZipcode()."'>";	      
				    	echo "</div>";
				    echo "</div>";
					echo "<div class='efebProfileLocationRow'>";
						echo "<div class='efebProfileLocationLabel'>"; echo JText::_( 'ECFIRMBOARD_CITY' ) . ": "; echo "</div>";
						echo "<div class='efebProfileLocationValue'>";
		            			echo "<input type='text' name='city' id='city' size='30' maxlength='100' value='".$EcfirmboardUser->getCity()."'>";
					    echo "</div>";
				    echo "</div>";
					echo "<div class='efebProfileLocationRow'>";
						echo "<div class='efebProfileLocationLabel'>"; echo JText::_( 'ECFIRMBOARD_COUNTRY' ) . ": "; echo "</div>";
						echo "<div class='efebProfileLocationValue'>"; include( 'components/com_ecboard/includes/countryselect.php'); echo "</div>";
				    echo "</div>";
			    echo "</div>";
				echo "<div class='efebProfileStatusBox'>";
					echo "<div class='efebProfileStatusHeader'>";
						echo "<div class='efebProfileHeader'>"; echo JText::_( 'ECFIRMBOARD_FORUM_STATUS' ); echo "</div>";
			    	echo "</div>";
					echo "<div class='efebProfileStatusRow'>";
						echo "<div class='efebProfileStatusLabel'>"; echo JText::_( 'ECFIRMBOARD_POSTS' ) . ": "; echo "</div>";
						echo "<div class='efebProfileStatusValue'>"; echo $EcfirmboardUser->getPosts(); echo "</div>";
				    echo "</div>";
					echo "<div class='efebProfileStatusRow'>";
						echo "<div class='efebProfileStatusLabel'>"; echo JText::_( 'ECFIRMBOARD_MODERATED' ) . ": "; echo "</div>";
						echo "<div class='efebProfileStatusValue'>";
							if ( $EcfirmboardUser->isRookie() || $EcfirmboardUser->isModerated()) { echo JText::_( 'ECFIRMBOARD_YES' ); }
							else { echo JText::_( 'ECFIRMBOARD_NO' ); }
					    echo "</div>";
				    echo "</div>";
			    echo "</div>";
			echo "</td>";    
			// left column
			// right column		
			echo "<td align='left' valign='top' width='50%' class='efebnoborder' style='padding: 10px;' >";
				echo "<div class='efebProfileAvatarBox'>";
					echo "<div class='efebProfileAvatarHeader'>";
						echo "<div class='efebProfileHeader'>"; echo JText::_( 'ECFIRMBOARD_AVATAR' ); echo "</div>";
			    	echo "</div>";
					echo "<div class='efebProfileAvatarRow'>";
					    echo "<div class='efebAvatarBox'>";			    			    
					    	if ( $EcfirmboardUser->getAvatar() == "") { 
					        	echo "<img src='" . $_root . "components/com_ecboard/assets/users/user.png' class='efebAvatar' alt='$user->username' />";
					    	} else { 
					        	echo "<img src='" . $_root . "images/ecboard/users/".$user->id."/large/".$EcfirmboardUser->getAvatar()."' class='efebAvatar' alt='$user->username' />";					        	
					    	}			    
					    echo "</div>";
					    if ( $EcfirmboardUser->getAvatar() != "") {
				    		echo "<div>"; echo "<input type='checkbox' name='cb_avatar' value='1'> " . JText::_( 'ECFIRMBOARD_AVATAR_DELETE' ); echo "</div>";
				    	}
				    echo "</div>";
					echo "<div class='efebProfileAvatarRow'>";				    			    
						echo "<div class='efebTextHeader'>" . JText::_( 'ECFIRMBOARD_AVATAR_UPLOAD' ) . ":</div> ";
		                	echo "<input class='efebText' type='file' name='avatar'>";								
		        		echo "<div class='efebTextFooter'>" . JText::_( 'ECFIRMBOARD_AVATAR_FILE_INFO' ) . "</div> ";
				    echo "</div>";
			    echo "</div>";
			echo "</td>";    
			// right column
		echo "</tr>";
		echo "<tr>";
			echo "<td align='left' valign='top' style='padding: 5px;' colspan='2' class='efebnoborder'>";
				echo "<div class='efebProfileSignatureBox'>";
					echo "<div class='efebProfileSignatureHeader'>";
						echo "<div class='efebProfileHeader'>"; echo JText::_( 'ECFIRMBOARD_SIGNATURE' ); echo "</div>";
			    	echo "</div>";
					echo "<div class='efebProfileSignatureRow'>";
						echo "<div class='efebTextHeader'>" . JText::_( 'ECFIRMBOARD_TEXT' ) . ":</div> ";
							echo "<div class='efebText'>";			    			
								echo "<textarea name='signature' cols='70' rows='3' wrap='VIRTUAL' id='signature'>"; echo $this->signature; echo "</textarea>";
						echo "</div>";
		        		echo "<div class='efebTextFooter'>" . JText::_( 'ECFIRMBOARD_SIGNATURE_INFO' ) . "</div> ";
				    echo "</div>";
				    // website
					echo "<div class='efebProfileFollowMeRow'>";
						echo "<div class='efebProfileFollowMeLabel'>" . JText::_( 'ECFIRMBOARD_WEBSITE' ) . ":</div> ";
							echo "<div class='efebProfileFollowMeValue'>";			    			
		            			echo "<input type='text' name='website' id='website' size='40' maxlength='100' value='".$this->website."'>";
						echo "</div>";
				    echo "</div>";
			    echo "</div>";
			echo "</td>";    			    			
		echo "</tr>";
		echo "<tr>";
			echo "<td align='left' valign='top' style='padding: 5px;' colspan='2' class='efebnoborder'>";
				echo "<div class='efebProfileFollowMeBox'>";
					echo "<div class='efebProfileFollowMeHeader'>";
						echo "<div class='efebProfileHeader'>"; echo JText::_( 'ECFIRMBOARD_FOLLOW_ME' ); echo "</div>";
			    	echo "</div>";
			    	echo "<div class='efebProfileFollowMeRow'>"; echo JText::_( 'ECFIRMBOARD_FOLLOW_ME_INFO' ) . ":"; echo "</div>";
				    // twitter
					echo "<div class='efebProfileFollowMeRow'>";
						echo "<div class='efebProfileFollowMeLabel'>Twitter:</div> ";
							echo "<div class='efebProfileFollowMeValue'>";			    			
		            			echo "<input type='text' name='twitter' id='twitter' size='40' maxlength='100' value='".$this->twitter."'>";
						echo "</div>";
				    echo "</div>";
				    // facebook
					echo "<div class='efebProfileFollowMeRow'>";
						echo "<div class='efebProfileFollowMeLabel'>Facebook:</div> ";
							echo "<div class='efebProfileFollowMeValue'>";			    			
		            			echo "<input type='text' name='facebook' id='facebook' size='40' maxlength='100' value='".$this->facebook."'>";
						echo "</div>";
				    echo "</div>";
				    // flickr
					echo "<div class='efebProfileFollowMeRow'>";
						echo "<div class='efebProfileFollowMeLabel'>Flickr:</div> ";
							echo "<div class='efebProfileFollowMeValue'>";			    			
		            			echo "<input type='text' name='flickr' id='flickr' size='40' maxlength='100' value='".$this->flickr."'>";
						echo "</div>";
				    echo "</div>";
				    // youtube
					echo "<div class='efebProfileFollowMeRow'>";
						echo "<div class='efebProfileFollowMeLabel'>YouTube:</div> ";
							echo "<div class='efebProfileFollowMeValue'>";			    			
		            			echo "<input type='text' name='youtube' id='youtube' size='40' maxlength='100' value='".$this->youtube."'>";
						echo "</div>";
				    echo "</div>";
			    echo "</div>";
			echo "</td>";    			    			
		echo "</tr>";
		echo "<tr>";
			echo "<td align='left' valign='top' class='efebnoborder' style='padding: 5px;' colspan='2'>";
				echo "<div class='efebProfileFollowMeBox'>";
					echo "<div class='efebProfileFollowMeHeader'>";
						echo "<div class='efebProfileHeader'>"; echo JText::_( 'ECFIRMBOARD_OTHER_SETTINGS' ); echo "</div>";
			    	echo "</div>";
				    // show online status
					echo "<div class='efebProfileFollowMeRow'>";
						echo "<div class='efebProfileFollowMeLabel'  style='width: 150px;'>" . JText::_( 'ECFIRMBOARD_SHOW_ONLINE_STATUS' ) . ":</div> ";
						echo "<div class='efebProfileFollowMeValue'>";
							echo "<select id='show_online_status' name='show_online_status'>";	
								if ( $this->show_online_status == 0) {	
									echo "<option value='1'>" . JText::_( 'ECFIRMBOARD_YES' ) . "</option>";
									echo "<option value='0' selected='selected'>" . JText::_( 'ECFIRMBOARD_NO' ) . "</option>";
								} else {
									echo "<option value='1' selected='selected'>" . JText::_( 'ECFIRMBOARD_YES' ) . "</option>";
									echo "<option value='0'>" . JText::_( 'ECFIRMBOARD_NO' ) . "</option>";
								}
							echo "</select>";
						echo "</div>";
				    echo "</div>";
			    echo "</div>";
			echo "</td>";    			    			
		echo "</tr>";
		echo "<tr>";
			echo "<td align='left' valign='top' class='efebnoborder' style='padding-left: 10px;' colspan='2'>";
        		echo "<div class='efebTextButton'>";
					echo "<input type='hidden' name='task' value='save'>";  			            		
					echo "<input class='efebButton' type='submit' name='submit' value='" . JText::_( 'ECFIRMBOARD_SAVE' ) . "'>";
				echo "</div> ";
			echo "</td>";    			    			
		echo "</tr>";
	echo "</table>";
echo "</form>";
echo "</div>";
?>

<!-- HTML Box Bottom -->
<?php $htmlBoxProfileBottom = $params->get('htmlBoxProfileBottom', '');		
if ( $htmlBoxProfileBottom != "") {
	echo "<div class='efebHtmlBoxProfileBottom'>"; echo $htmlBoxProfileBottom; echo "</div>"; } ?>
<!-- HTML Box Bottom -->

<?php include( 'components/com_ecboard/includes/footer.php'); ?>
</div>