<?php
 /** 
 * @version        
 * @package        ecfirm
 * @subpackage    
 * @copyright    Copyright (C) 2011 Kilmeny.net. All rights reserved.
 * @license        GNU General Public License version 2 or later. 
 **/

defined('_JEXEC') or die('Restricted access');
JHTML::_('stylesheet', 'ecboard_nav.css', 'components/com_ecboard/assets/css/');
JHTML::_('stylesheet', 'ecboard_txt.css', 'components/com_ecboard/assets/css/');
JHTML::_('stylesheet', 'ecboard_usr.css', 'components/com_ecboard/assets/css/');
require_once(JPATH_COMPONENT.DS.'classes/user.php');
require_once(JPATH_COMPONENT.DS.'classes/helper.php');

$user =& JFactory::getUser();
$logUser = new EcfirmboardUser( $user->id);
$app = JFactory::getApplication();
$EcfirmboardHelper = new EcfirmboardHelper();
// get parameters
$params = JComponentHelper::getParams('com_ecboard');
// website root directory
$_root = JURI::root();
?>

<div class="efeb">
<?php if ( $this->params->def( 'show_page_title', 1 ) ) : ?>
	<div class="componentheading<?php echo $this->escape($this->params->get('pageclass_sfx')); ?>">
		<?php echo $this->escape($this->params->get('page_title')); ?>
	</div>
<?php endif; ?>

<!-- HTML Box Top -->
<?php $htmlBoxCategoryTop = $params->get('htmlBoxCategoryTop', '');
if ( $htmlBoxCategoryTop != "") {
	echo "<div class='efebHtmlBoxCategoryTop'>";
		echo $htmlBoxCategoryTop;
	echo "</div>";
} ?> <!-- HTML Box Top -->

<?php include( 'components/com_ecboard/includes/topmenu.php'); ?>

<?php echo "<h2 style='padding-left: 0px;'>";
    echo JText::_( "ECFIRMBOARD_HISTORY");
    echo " " . $this->hours . " ";
    echo JText::_( 'ECFIRMBOARD_HISTORY_HOURS');
echo "</h2>"; echo "<br />"; ?>

<!-- Breadcrumb -->
<?php $showBreadcrumbRow = $params->get('breadcrumb', '0');
if ( $showBreadcrumbRow == "1") { ?>
	<table class="efebnoborder" style="margin-top: 5px;">
	    <tr>
	        <td class="efebnoborder">
	            <?php $menuLinkHome 	= JRoute::_( 'index.php?option=com_ecboard');
				$menuText 		= $app->getMenu()->getActive()->title;	
	            echo "<a href='$menuLinkHome'>" . $menuText . "</a>"; ?>
	        </td>
	        <td class="efebnoborder">
	            <?php echo "&nbsp;&raquo;&nbsp;";
	            echo JText::_( "ECFIRMBOARD_HISTORY");
                echo " " . $this->hours . " ";
                echo JText::_( 'ECFIRMBOARD_HISTORY_HOURS'); ?>
	        </td>
	    </tr>
	</table>
<?php } ?>
<!-- Breadcrumb -->

<!-- Pagination Links -->
<table width="100%" class="efebnoborder" style="margin-bottom:10px;">
    <tr>
        <td class="efebnoborder"> <?php echo $this->pagination->getPagesLinks(); ?> </td>
        <td class="efebnoborder"> <?php echo $this->pagination->getPagesCounter(); ?> </td>
    </tr>
</table>
<!-- Pagination Links -->

<table width="100%" border="0" cellspacing="0" cellpadding="0">
    <tr>
		<td width="100px"   align="center" class="efebTableHeader"><?php echo JText::_( 'ECFIRMBOARD_AUTHOR' ); ?></td>
        <td  align="left"   class="efebTableHeader"><?php echo JText::_( 'ECFIRMBOARD_RECENT_POST_TITLE' ); ?></td>
    </tr>
	<?php $rowColor = 1; foreach ( $this->postings as $posting ) : ?>
    	<tr>
			<td align="center" class="efebIndexTableRow<?php echo $rowColor; ?> efebIndexTableRowReplies">
            <?php $EcfirmboardUser = new EcfirmboardUser( $posting->user_id);
            // $entryUsername = $EcfirmboardHelper->getUsernameById( $posting->user_id);
			$entryUsername = $EcfirmboardUser->getUsername();
            echo "<div class='efebCategoryAvatarBox'>";
                if ( $EcfirmboardUser->getAvatar() == "") { // display default avatar
                    echo "<img src='" . $_root . "components/com_ecboard/assets/users/user.png' class='efebCategoryDefaultAvatar' alt='" 
                    . $entryUsername . "' title='" . $entryUsername . "' />";
                } else { // display uploaded avatar
                    echo "<img src='" . $_root . "images/ecboard/users/".$posting->user_id."/small/".$EcfirmboardUser->getAvatar()
                    ."' class='efebCategoryAvatar' alt='" . $entryUsername . "' title='" . $entryUsername . "' />";
                }
            echo "</div>"; ?>
			</td>
            <td align="left" class="efebIndexTableRow<?php echo $rowColor; ?> efebIndexTableRowTopic">
                <?php $_hoverSubject 	= $posting->subject;
                    $_hoverSubject 	= str_replace( '\'', '"', $_hoverSubject);
                    $_categorySlug 	= $EcfirmboardHelper->getCategorySlugById( $posting->cat_id);
                    $_categoryName 	= $EcfirmboardHelper->getCategoryNameById( $posting->cat_id);
                    $_threadSlug 	= $EcfirmboardHelper->getThreadSlugById( $posting->thread);
                    $_postingJumpPoint = $EcfirmboardHelper->getPostingJumpPointByThreadIdAndPostingId( $posting->thread, $posting->id);
                    $postingLinkTMP = "index.php?option=com_ecboard&view=thread&catid=" . $_categorySlug . "&thread=" . $_threadSlug;
                    $postingLinkTMP .= $_postingJumpPoint;
                    $postingLink = JRoute::_( $postingLinkTMP);
                    echo "<a href='$postingLink' title='".$_hoverSubject."'>".$posting->subject."</a>";
                    echo "<div class='efebIndexTableRowTopicSubtitle'>";
                        echo JText::_( 'ECFIRMBOARD_POSTED' ) . " " . $posting->date_created . " " . JText::_( 'ECFIRMBOARD_BY' ) . " ";
                        echo "<b>"; echo $entryUsername; echo "</b>";
                        echo " " . JText::_( 'ECFIRMBOARD_IN' ) . " ";
                        $forum_link = JRoute::_('index.php?option=com_ecboard&view=category&catid=' . $EcfirmboardHelper->getCategorySlugById( $posting->cat_id));
                        echo "<a href='" . $forum_link . "' title=\"" . $_categoryName . "\" >"; echo $_categoryName; echo "</a>";
                    echo "</div>";
                ?>
            </td>
    	</tr>
		<?php // toggle row color
		if ( $rowColor == 1) { $rowColor = 2; }
		else { $rowColor = 1; }
	endforeach; ?>
</table>

<!-- Pagination Links -->
<table width="100%" class="efebnoborder" style="margin-top:10px;">
    <tr>
        <td class="efebnoborder"> <?php echo $this->pagination->getPagesLinks(); ?> </td>
        <td class="efebnoborder"> <?php echo $this->pagination->getPagesCounter(); ?> </td>
    </tr>
</table>
<!-- Pagination Links -->

<!-- Breadcrumb -->
<?php if ( $showBreadcrumbRow == "1") { ?> 
	<table class="efebnoborder" style="margin-top: 5px;">
	    <tr>
	        <td class="efebnoborder">
	            <?php echo "<a href='$menuLinkHome'>" . $menuText . "</a>"; ?>
	        </td>
	        <td class="efebnoborder">
	            <?php echo "&nbsp;&raquo;&nbsp;";
                echo JText::_( "ECFIRMBOARD_HISTORY");
                echo " " . $this->hours . " ";
                echo JText::_( 'ECFIRMBOARD_HISTORY_HOURS'); ?>
	        </td>
	    </tr>
	</table>
<?php } ?>
<!-- Breadcrumb -->

<?php include( 'components/com_ecboard/includes/share.php'); ?>

<!-- HTML Box Bottom -->
<?php $htmlBoxCategoryBottom = $params->get('htmlBoxCategoryBottom', '');
 if ( $htmlBoxCategoryBottom != "") { echo "<div class='efebHtmlBoxCategoryBottom'>"; echo $htmlBoxCategoryBottom; echo "</div>"; } ?>
<!-- HTML Box Bottom -->

<?php include( 'components/com_ecboard/includes/footer.php'); ?>
</div>