<?php
 /** 
 * @version        
 * @package        ecfirm
 * @subpackage    
 * @copyright    Copyright (C) 2011 Kilmeny.net. All rights reserved.
 * @license        GNU General Public License version 2 or later. 
 **/
defined('_JEXEC') or die('Restricted access');
JHTML::_('stylesheet', 'ecboard_nav.css', 'components/com_ecboard/assets/css/');
JHTML::_('stylesheet', 'ecboard_txt.css', 'components/com_ecboard/assets/css/');
JHTML::_('stylesheet', 'ecboard_usr.css', 'components/com_ecboard/assets/css/');
require_once( JPATH_COMPONENT.DS.'classes/user.php');
require_once( JPATH_COMPONENT.DS.'classes/helper.php');

$app = JFactory::getApplication();
$user =& JFactory::getUser();
$logUser = new EcfirmboardUser( $user->id);
$EcfirmboardHelper = new EcfirmboardHelper();
$document =& JFactory::getDocument(); // set page title and description
$title = $document->getTitle();
$title = $this->subject . " - " . $this->categoryName; // $siteName = $mainframe->getCfg('sitename');
$document->setTitle( $title); //$title = $title . " | " . $siteName;
$_metaDescription = trim( ereg_replace( "\n", " ", $this->metaDescription)); //$document->setDescription( $this->subject . " " . $this->categoryName); 
$_metaDescription = ereg_replace( "\r", " ", $_metaDescription);
$_metaDescription = ereg_replace( "\"", " ", $_metaDescription);
$_metaDescription = ereg_replace( "<", " ", $_metaDescription);
$_metaDescription = ereg_replace( ">", " ", $_metaDescription);
$_metaDescription = ereg_replace( "/", " ", $_metaDescription);
$_metaDescription = ereg_replace( ' +', ' ', $_metaDescription);
$document->setDescription( substr ( $_metaDescription, 0, 160)); 
if ( $this->metaKeywords == "") { // $document->setMetaData( "keywords", "");
} else { $document->setMetaData( "keywords", $this->metaKeywords); } // use the meta keywords configured for this forum

// get parameters
$params = JComponentHelper::getParams('com_ecboard');
$_imagesDisplayMode 	= $params->get( 'imagesDisplayMode', 0); // 0 Browser, 1 Slimbox, 2 RokBox
$_includeMootoolsJS 	= $params->get( 'includeMootoolsJS', 0); // 0 no, 1 yes
$_includeSlimboxJS  	= $params->get( 'includeSlimboxJS', 0);  // 0 no, 1 yes
$_usePrimezilla 		= $params->get( 'usePrimezilla', 0);  // 0 no, 1 yes
$_callPrimezillaMode 	= $params->get( 'callPrimezillaMode', 0); // 0 username, 1 userid

// Flickr
$_useFlickr 	      	= $params->get( 'useFlickr', 0);  // 0 no, 1 yes
$_flickr_display_mode 	= $params->get( 'flickr_display_mode', 0); // 0 Browser, 1 Slimbox, 2 RokBox, 3 YOOeffects
$_flickr_cache_mode   	= $params->get( 'flickr_cache_mode', 0 ); // 0 = off, 1 = on
$_flickr_cache_time   	= $params->get( 'flickr_cache_time', 7200 ); // default 7200 seconds = 2 hours

// YouTube
$_useYouTube 	      	= $params->get( 'useYouTube', '0');  // 0 no, 1 yes
$_youtube_video_width 	= $params->get( 'youtube_video_width', '640');  // default 640 pixel
$_youtube_video_height	= $params->get( 'youtube_video_height', '385');  // default 385 pixel

if ( $_useFlickr == 1) {
    $_flickr_apikey     = $params->get( 'flickr_apikey', '');
    require_once( JPATH_COMPONENT.DS.'includes/phpflickr/phpFlickr.php');
    $f = new phpFlickr( $_flickr_apikey);
    if ( $_flickr_cache_mode == 1) {
        $config = new JConfig();
        $_host 	    = $config->host;
        $_db 		= $config->db;
        $_dbprefix  = $config->dbprefix;
        $_user 	    = $config->user;
        $_password  = $config->password;
        $_flickr_connect = "mysql://" . $_user . ":" . $_password . "@" . $_host . "/" . $_db;
        $_flickr_cache_table = $_dbprefix . "ecboard_flickr_cache";
        $f->enableCache( "db", $_flickr_connect, $_flickr_cache_time, $_flickr_cache_table );
    }
}

// Slimbox
if ( $_imagesDisplayMode == 1) { 
	$assets = JURI::root() . "components/com_ecboard/assets";
	$document->addStyleSheet( $assets.'/css/slimbox.css'); }
// website root directory
$_root = JURI::root();



echo "<div class='efeb'>";

echo "<script type='text/javascript'>";
	echo "function confirmdelete() { ";
 		echo "return confirm('" . JText::_( 'ECFIRMBOARD_CONFIRM_DELETE' ) . "');";
	echo "}"; 		
echo "</script>";

//Javascript functions
if ( $_includeMootoolsJS == 1) { // include Mootools JS
	echo "<script type=\"text/javascript\" src=\"" . $assets . "/js/mootools.js\"></script>"; }	
if ( $_includeSlimboxJS == 1) { // include Slimbox JS
	echo "<script type=\"text/javascript\" src=\"" . $assets . "/js/slimbox.js\"></script>"; }	
?>

<script type="text/javascript">
    function callURL(obj) {
        $catid 		= obj.options[obj.selectedIndex].value;
		var length 	= slugsarray.length;
		for(var k=0; k < slugsarray.length; k++) {
			// if selected index found jump to category
			if ( slugsarray[k][0] == $catid) {
         		location.href = slugsarray[k][1];
        	}
		}			
    }
</script>
<!-- Javascript functions -->

<?php /* if ( $this->params->def( 'show_page_title', 1 ) ) : ?>
	<div class="componentheading<?php echo $this->escape($this->params->get('pageclass_sfx')); ?>">
		<?php echo $this->escape($this->params->get('page_title')); ?>
	</div>
<?php endif; */ ?>



<!-- HTML Box Top -->
<?php $htmlBoxThreadTop = $params->get('htmlBoxThreadTop', '');
if ( $htmlBoxThreadTop != "") {
	echo "<div class='efebHtmlBoxThreadTop'>";
		echo $htmlBoxThreadTop;
	echo "</div>";
} ?>
<!-- HTML Box Top -->



<?php //include( 'components/com_ecboard/includes/topmenu.php'); ?>



<!-- Category icon, name and description -->
<table width="100%" class="efebnoborder" style="margin-bottom:10px;">
    <tr>
    	<?php echo "<td align='left' valign='middle' class='efebnoborder'>";                	
   		if ( $user->guest) {
   			$registerURL = "index.php?option=com_users&view=registration";
   			$loginURL    = "index.php?option=com_users&view=login"; 
          	echo "<a href='" . JRoute::_( $loginURL) . "' >" . JText::_( 'ECFIRMBOARD_NO_PUBLIC_WRITE_LOGIN' ) . "</a> | ";
           	echo "<a href='" . JRoute::_( $registerURL) . "' >" . JText::_( 'ECFIRMBOARD_NO_PUBLIC_WRITE_REGISTER' ) . "</a>";
   		} else	{
           	echo "<img src='" . $_root . "components/com_ecboard/assets/threads/new.png' style='margin-left: 5px; margin-right: 5px; border:0px;' />";
           	$menuLinkNewTMP = "index.php?option=com_ecboard&view=posting&task=new&catid=".$this->categorySlug;
           	$menuLinkNew = JRoute::_( $menuLinkNewTMP);
            echo "<a href='".$menuLinkNew."'>" . JText::_( 'ECFIRMBOARD_NEW_THREAD' ) . "</a>";
   		}
		echo "</td>"; ?>
        <!-- category name and description -->
        <td align="right" class="efebnoborder">
            <?php //echo $this->categoryName; ?><?php echo $EcfirmboardHelper->getQuickJumpSelectBox( $this->categoryId); ?>
        </td> <!-- category name and description -->
    </tr>
</table>
<!-- Category icon, name and description -->



<?php // Forum specific top banner
if ( $this->forumBannerTop != "") {
	echo "<table width='100%' border='0' class='efebnoborder' style='margin-top:10px;'>";
	    echo "<tr>";
	    	echo "<td width='100%' align='center' class='efebnoborder'>"; ?>
				<script type='text/javascript'> <?php	echo $this->forumBannerTop; ?> </script>
			<?php echo "</td>"; 
	    echo "</tr>"; 
	echo "</table>"; 
} // Forum specific top banner ?>



<!-- Post, Reply,... Links -->
<?/* php if ( $user->guest) { // user is not logged in ///////////////
	//echo "<table width='100%' class='efebnoborder' style='margin:20px 0px 20px 0px;' border='0' >";
	echo "<table width='100%' class='efebnoborder' style='margin:0px 0px 0px 0px;' border='0' >";
    	echo "<tr>";
        	echo "<td width='100%' align='left' valign='middle' class='efebnoborder'>";
        		$registerURL = "index.php?option=com_users&view=registration";
        		$loginURL    = "index.php?option=com_users&view=login"; 
            	echo JText::_( 'ECFIRMBOARD_NO_PUBLIC_WRITE' );
            	echo "<a href='" . JRoute::_( $loginURL) . "' >" . JText::_( 'ECFIRMBOARD_NO_PUBLIC_WRITE_LOGIN' ) . "</a>";
            	echo JText::_( 'ECFIRMBOARD_OR' );
            	echo "<a href='" . JRoute::_( $registerURL) . "' >" . JText::_( 'ECFIRMBOARD_NO_PUBLIC_WRITE_REGISTER' ) . "</a>";
            echo "</td>";
        echo "</tr>";
    echo "</table>";
	//echo "<table class='efebnoborder' style='margin:20px 0px 20px 0px;'>";
	echo "<table class='efebnoborder' style='margin:0px 0px 0px 0px;'>";
    	echo "<tr>";
        	echo "<td width='16' align='center' valign='middle' class='efebnoborder' style='padding-left: 0px;'>";
            	echo "<img src='" . $_root . "components/com_ecboard/assets/system/lastentry.png' style='margin-left: 5px; margin-right: 5px; border:0px;' />";
        	echo "</td>";
        	echo "<td align='left' valign='middle' class='efebnoborder'>";
				$menuLinkLastTMP = "index.php?option=com_ecboard&view=thread&catid=" . $this->categorySlug . "&thread=" . $this->threadSlug;
				$menuLinkLastTMP .= $this->lastEntryJumpPoint;
            	$menuLinkLast = JRoute::_( $menuLinkLastTMP);
            	echo "<a href='".$menuLinkLast."'>" . JText::_( 'ECFIRMBOARD_GOTO_LAST_ENTRY' ) . "</a>";
        	echo "</td>";        
    	echo "</tr>";
    echo "</table>";
} // user is not logged in ///////////////



else { // user is logged in ////////////
	//echo "<table class='efebnoborder' style='margin:20px 0px 20px 0px;'>";
	echo "<table class='efebnoborder' style='margin:0px 0px 0px 0px;'>";
    	echo "<tr>";       	
    		if ( $this->lockedStatus == 0 || $logUser->isModerator()) { // thread is not locked or user is moderator
        		echo "<td width='16' align='center' valign='middle' class='efebnoborder' style='padding-left: 0px;' >";
            		echo "<img src='" . $_root . "components/com_ecboard/assets/threads/reply.png' style='margin-left: 15px; margin-right: 5px; border:0px;' />";
        		echo "</td>";
        		echo "<td align='left' valign='middle' class='efebnoborder'>";
            		$menuLinkReplyTMP = "index.php?option=com_ecboard&view=posting&task=reply&catid=".$this->categorySlug."&thread=".$this->thread."&parent=".$this->threadId;
            		$menuLinkReply = JRoute::_( $menuLinkReplyTMP);
            		echo "<a href='".$menuLinkReply."'>" . JText::_( 'ECFIRMBOARD_REPLY1' ) . "</a>";
        		echo "</td>";
			}
        	echo "<td width='16' align='center' valign='middle' class='efebnoborder' style='padding-left: 20px;'>";
            	echo "<img src='" . $_root . "components/com_ecboard/assets/threads/new.png' style='margin-left: 5px; margin-right: 5px; border:0px;' />";
        	echo "</td>";
        	echo "<td align='left' valign='middle' class='efebnoborder'>";
            	$menuLinkNewTMP = "index.php?option=com_ecboard&view=posting&task=new&catid=" . $this->categorySlug;
            	$menuLinkNew = JRoute::_( $menuLinkNewTMP);
            	echo "<a href='".$menuLinkNew."'>" . JText::_( 'ECFIRMBOARD_NEW_THREAD' ) . "</a>";
        	echo "</td>";                	
        	echo "<td width='16' align='center' valign='middle' class='efebnoborder' style='padding-left: 20px;'>";
            	echo "<img src='" . $_root . "components/com_ecboard/assets/system/lastentry.png' style='margin-left: 5px; margin-right: 5px; border:0px;' />";
        	echo "</td>";
        	echo "<td align='left' valign='middle' class='efebnoborder'>";
				$menuLinkLastTMP = "index.php?option=com_ecboard&view=thread&catid=" . $this->categorySlug . "&thread=" . $this->threadSlug;
				$menuLinkLastTMP .= $this->lastEntryJumpPoint;
            	$menuLinkLast = JRoute::_( $menuLinkLastTMP);
            	echo "<a href='".$menuLinkLast."'>" . JText::_( 'ECFIRMBOARD_GOTO_LAST_ENTRY' ) . "</a>";
        	echo "</td>";        
    	echo "</tr>";
	echo "</table>";
} // user is logged in //////////// */ ?> <!-- Post, Reply,... Links -->



<!-- Breadcrumb -->
<?php $showBreadcrumbRow = $params->get('breadcrumb', '0');		
if ( $showBreadcrumbRow == "1") { ?>
	<!-- table class="efebnoborder" style="margin-top: 5px;" -->
	<table class="efebnoborder" style="margin-bottom: 5px;">
	    <tr>
	        <td class="efebnoborder">
	            <?php $menuLinkHome     = JRoute::_( 'index.php?option=com_ecboard');
				$menuText = $app->getMenu()->getActive()->title;	
	            echo "<a href='$menuLinkHome'>" . $menuText . "</a>"; ?>
	        </td>
	        <td class="efebnoborder">
	            <?php $menuLinkCategoryTMP = "index.php?option=com_ecboard&view=category&catid=".$this->categorySlug;
	            $menuLinkCategory = JRoute::_( $menuLinkCategoryTMP);
	            echo "&nbsp;&raquo;&nbsp;";
	            echo "<a href='$menuLinkCategory'>".$this->categoryName."</a>"; ?>
	        </td>
	        <td class="efebnoborder">
	            <?php echo "&nbsp;&raquo;&nbsp;";
	            echo $this->subject; ?>
	        </td>
	    </tr>
	</table>
<?php } ?> <!-- Breadcrumb -->



<table width="100%" border="0" cellspacing="0" cellpadding="5" class="efebnoborder">
	<?php $rowColor = 1; $counter  = 1;
	foreach ( $this->postings as $posting ) : ?>
    	<tr> 
    	
    		<!-- // username, posts, online ////////////////// -->
			<?php /* <td width="100" align="center" valign="top" class="efebThreadTableRow<?php echo $rowColor; ?> efebThreadBorder1" >
                <?php $EcfirmboardUser = new EcfirmboardUser( $posting->user_id);
                $opUserUsername = $EcfirmboardUser->getUsername();
                // display username
                echo "<b>".$opUserUsername."</b><br />";
				$_posts = $EcfirmboardUser->getPosts();
				if ( $_posts == 1) { echo $_posts . " " . JText::_( 'ECFIRMBOARD_POST' ); }
				else { echo $_posts . " " . JText::_( 'ECFIRMBOARD_POSTSCOUNTER' ); }			
				// online status	
				if ( $user->guest) { // user is not logged in 
					echo "<div class='efebAvatarColumnOnlineStatusOffline'>".JText::_( 'ECFIRMBOARD_OFFLINE_GUEST' )."</div>";
					} else { // user is logged in
						if ( $EcfirmboardUser->getShowOnlineStatus() && $EcfirmboardHelper->isUserOnlineById( $posting->user_id)) {
							echo "<div class='efebAvatarColumnOnlineStatusOnline'>".JText::_( 'ECFIRMBOARD_ONLINE' )."</div>"; }
						else { echo "<div class='efebAvatarColumnOnlineStatusOffline'>".JText::_( 'ECFIRMBOARD_OFFLINE' )."</div>"; } 
				}           
                echo "</div>"; ?>
			</td> */ ?><!-- // username, posts, online ////////////////// -->
			
			
			
			<td align="left" valign="top" class="efebThreadTableRow<?php echo $rowColor; ?> efebThreadBorder2" >
				<?php echo "<a name='p" . $posting->id . "'></a>";	 echo $posting->date;
				$EcfirmboardUser = new EcfirmboardUser( $posting->user_id);
				$opUserUsername = $EcfirmboardUser->getUsername();
                echo " <b>".$opUserUsername."</b>"; // display username
                // online status	
				if ( $EcfirmboardUser->getShowOnlineStatus() && $EcfirmboardHelper->isUserOnlineById( $posting->user_id))
					echo "(".JText::_( 'ECFIRMBOARD_ONLINE' ).")";
				else echo "(".JText::_( 'ECFIRMBOARD_OFFLINE' ).")"; 
                echo "</div>";
                
				$pageOffset = JRequest::getVar('limitstart', 0, '', 'int');
				echo "<div style='margin: 5px 0px 5px 0px;'><b>".$posting->subject."</b><div class='efebHorizontalRuler'></div>";
				
				
				
				// message ///////////////////
                $message = $posting->message;
				// close html tags
				$message = $EcfirmboardHelper->close_html_tags( $message);
				$message = nl2br( $message);
				echo "<span class='efebMessage'>".$message."</span><br /><br />";

				
				
				// image attachements ///////////////
				if 	( 	$posting->image1 != "" ||
						$posting->image2 != "" ||
						$posting->image3 != "" ||
						$posting->image4 != "" ||
						$posting->image5 != "" ) { // found attachement(s)
					echo "<div class='efebImageAttachmentRow'>";
					$_titleprefix = "";
					switch ( $_imagesDisplayMode) { // set rel and target
						case 1: { // Slimbox
							$_linktag = " rel='lightbox-" . $posting->id . "' "; break; }
						case 2: { // RokBox
							$_linktag = " rel='rokbox (" . $posting->id . ")' "; $_titleprefix = $posting->subject . " :: "; break; } 
						case 3: { // YOOeffects
                            $_linktag = " rel='shadowbox[" . $posting->id . "]' "; break; } 
						default: { // Set to Browser display by default
							$_linktag = " target='_blank' "; break; } 
					}
				    if ( $posting->image1 != "") { 
   						echo "<div class='efebImageAttachment1'>";
							echo "<a href='" . $_root . "images/ecboard/posts/".$posting->thread."/".$posting->id."/large/"
								.$posting->image1."' " .$_linktag . " title='".$_titleprefix.$posting->image1_description . "' >";
							echo "<img src='" . $_root . "images/ecboard/posts/".$posting->thread."/".$posting->id."/small/"
								.$posting->image1."' alt='.".$posting->image1_description."' class='efebAttachmentImageEdit' />";
							echo "</a>";
   						echo "</div>";
				    }			    
				    if ( $posting->image2 != "") { 
   						echo "<div class='efebImageAttachment2'>";
							echo "<a href='" . $_root . "images/ecboard/posts/".$posting->thread."/".$posting->id."/large/"
								.$posting->image2."' " . $_linktag . " title='".$_titleprefix.$posting->image2_description . "' >";
							echo "<img src='" . $_root . "images/ecboard/posts/".$posting->thread."/".$posting->id."/small/"
								.$posting->image2."' alt='.".$posting->image2_description."' class='efebAttachmentImageEdit' />";
							echo "</a>";
   						echo "</div>";
				    }			    
				    if ( $posting->image3 != "") { 
   						echo "<div class='efebImageAttachment3'>";
							echo "<a href='" . $_root . "images/ecboard/posts/".$posting->thread."/".$posting->id."/large/"
								.$posting->image3."' " . $_linktag . " title='".$_titleprefix.$posting->image3_description . "' >";
							echo "<img src='" . $_root . "images/ecboard/posts/".$posting->thread."/".$posting->id."/small/"
								.$posting->image3."' alt='.".$posting->image3_description."' class='efebAttachmentImageEdit' />";
							echo "</a>";
   						echo "</div>";
				    }			    
				    if ( $posting->image4 != "") { 
   						echo "<div class='efebImageAttachment4'>";
							echo "<a href='" . $_root . "images/ecboard/posts/".$posting->thread."/".$posting->id."/large/"
								.$posting->image4."' " . $_linktag . " title='".$_titleprefix.$posting->image4_description . "' >";
							echo "<img src='" . $_root . "images/ecboard/posts/".$posting->thread."/".$posting->id."/small/"
								.$posting->image4."' alt='.".$posting->image4_description."' class='efebAttachmentImageEdit' />";
							echo "</a>";
   						echo "</div>";
				    }			    
				    if ( $posting->image5 != "") { 
   						echo "<div class='efebImageAttachment5'>";
							echo "<a href='" . $_root . "images/ecboard/posts/".$posting->thread."/".$posting->id."/large/"
								.$posting->image5."' " . $_linktag . " title='".$_titleprefix.$posting->image5_description . "' >";
							echo "<img src='" . $_root . "images/ecboard/posts/".$posting->thread."/".$posting->id."/small/"
								.$posting->image5."' alt='.".$posting->image5_description."' class='efebAttachmentImageEdit' />";
							echo "</a>";
   						echo "</div>";
				    }			    
					echo "<div class='clr' style='margin-bottom:5px'></div>";
					echo "</div><br /><br />";				
				} // image attachements ///////////////
				
				
				
                /* $signature = nl2br($EcfirmboardUser->getSignature());
                if ( $signature != "") { // display signature hr if one is present
                    echo "<div class='efebHorizontalRuler'></div>".$signature; }
				$website = $EcfirmboardUser->getWebsite();
                if ( $website != "") { // display website 
                	echo "<br />";                
                	if ( $signature == "") { // draw hr if no signature is available
                    	echo "<div class='efebHorizontalRuler'></div>"; }
                    echo "<a href='http://" . $website . "' target='_blank' title='" . $website . "' rel='nofollow'>".$website."</a>";
                }
                echo "<br /><br />"; */
                
                
                
                if ( !$user->guest) { // user is logged in. display menue in post //////////////
                	echo "<div class='efebPostMenu'>";
							if ( $this->lockedStatus == 0 || $logUser->isModerator()) { // thread is not locked or user is moderator
								
					        	// reply to post ////////////////
								echo "<div class='efebPostMenuItem'>";
									echo "<div class='efebPostMenuIcon'>";
					            		echo "<img src='" . $_root . "components/com_ecboard/assets/threads/reply.png' />";
					            	echo "</div>";
									echo "<div class='efebPostMenuText'>";
						                echo "<div class='efebPostMenuLinks'>";
						                    $menuLinkReplyTMP = "index.php?option=com_ecboard&view=posting&task=reply&catid=".$this->categorySlug."&thread=".$this->thread."&parent=".$posting->id;
						                    $menuLinkReply = JRoute::_( $menuLinkReplyTMP);
						                    echo "<a href='".$menuLinkReply."'>" . JText::_( 'ECFIRMBOARD_REPLY2' ) . "</a>";
						                echo "</div>";
						        	echo "</div>";
								echo "</div>";
								// reply to post ////////////////
								
					        	// reply to post with quote  //////////////////
								/* echo "<div class='efebPostMenuItem'>";
									echo "<div class='efebPostMenuIcon'>";
					            		echo "<img src='" . $_root . "components/com_ecboard/assets/threads/quote.png' />";
					            	echo "</div>";
					            	echo "<div class='efebPostMenuText'>";
						            	echo "<div class='efebPostMenuLinks'>";
											$menuLinkQuoteTMP = "index.php?option=com_ecboard&view=posting&task=quote&catid=".$this->categorySlug."&thread=".$this->thread."&parent=".$posting->id."&id=".$posting->id;
											$menuLinkQuote = JRoute::_( $menuLinkQuoteTMP);
											echo "<a href='".$menuLinkQuote."'>" . JText::_( 'ECFIRMBOARD_QUOTE2' ) . "</a>";
						            	echo "</div>";
						            echo "</div>";	
								echo "</div>"; */
								// reply to post with quote  //////////////////
								
								// edit post. check if user is post owner or has moderator rights								
					        	$date = $posting->date;
					        	$day = substr( $date, 0, 2);  // 1 + 2 char
					        	$month = substr( $date, 3, 2);  // 4 + 5 char
					        	$year = substr( $date, 6, 4);  // 7 - 10 char
					        	$hour = substr( $date, 11, 2);  // 12 + 13 char
					        	$minute = substr( $date, 14, 2);  // 15 + 16 char					        	
					        	//date_default_timezone_set ( "Europe/Berlin");
					        	$now = time(); // current unixtime
					        	$posttime = mktime( $hour, $minute, 0, $month, $day, $year); // unixtime from post date
					        	$isUserEditable = true;
					        	// get editTime in minutes from global parameters
					        	$editTime = $params->get('editTime', '30');		
					        	if ( ($now - $posttime) > ( $editTime * 60)) { $isUserEditable = false; }
					       		$editForever = $params->get('editForever', '1');		
					       		if ( $editForever == 1) { $isUserEditable = true; }
					        	if ( $logUser->isModerator() || ( ($logUser->getId() == $EcfirmboardUser->getId()) && $isUserEditable == true)) {
									echo "<div class='efebPostMenuItem'>";
										echo "<div class='efebPostMenuIcon'>";
						                	echo "<img src='" . $_root . "components/com_ecboard/assets/threads/edit.png' />";
						            	echo "</div>";	
										echo "<div class='efebPostMenuText'>";
						                	echo "<div class='efebPostMenuLinks'>";
												$menuLinkEditTMP = "index.php?option=com_ecboard&view=posting&task=edit&catid=".$this->categorySlug."&thread=".$this->thread."&parent=".$posting->id."&id=".$posting->id;
												$menuLinkEdit = JRoute::_( $menuLinkEditTMP);
												echo "<a href='".$menuLinkEdit."'>" . JText::_( 'ECFIRMBOARD_EDIT' ) . "</a>";
						                	echo "</div>";
					            		echo "</div>";						                	
					            	echo "</div>";
					            	
					            	// delete post / thread ////////////////
					            	echo "<div class='efebPostMenuItem'>";
										echo "<div class='efebPostMenuIcon'>";
											echo "<img src='" . $_root . "components/com_ecboard/assets/threads/delete.png' />";
					            		echo "</div>";						                	
										echo "<div class='efebPostMenuText'>";
											echo "<div class='efebPostMenuLinks'>";
												$menuLinkDeleteTMP = "index.php?option=com_ecboard&view=moderation&task=delete&id=".$posting->id;
												$menuLinkDelete = JRoute::_( $menuLinkDeleteTMP);
												echo "<a href='".$menuLinkDelete."' onclick='return confirmdelete();'>" . JText::_( 'ECFIRMBOARD_DELETE' ) . "</a>";
											echo "</div>";
					            		echo "</div>";						                	
									echo "</div>";
									// delete post / thread ////////////////
					        	}
							} // if locked == 0 or user is moderator
							else {
									echo "<div class='efebPostMenuItem'>";
										echo "<div class='efebPostMenuIcon'>";
											echo "<img src='" . $_root . "components/com_ecboard/assets/threads/lock.png' />";
					            		echo "</div>";						                	
										echo "<div class='efebPostMenuText'>";
											echo "<div class='efebPostMenuLinks'>";
												echo JText::_( 'ECFIRMBOARD_THREAD_IS_LOCKED' );									
											echo "</div>";
					            		echo "</div>";						                	
									echo "</div>";
							}
							
							// delete post / thread ////////////////
							/* if ( $logUser->isModerator()) {
									echo "<div class='efebPostMenuItem'>";
										echo "<div class='efebPostMenuIcon'>";
											echo "<img src='" . $_root . "components/com_ecboard/assets/threads/delete.png' />";
					            		echo "</div>";						                	
										echo "<div class='efebPostMenuText'>";
											echo "<div class='efebPostMenuLinks'>";
												$menuLinkDeleteTMP = "index.php?option=com_ecboard&view=moderation&task=delete&id=".$posting->id;
												$menuLinkDelete = JRoute::_( $menuLinkDeleteTMP);
												echo "<a href='".$menuLinkDelete."' onclick='return confirmdelete();'>" . JText::_( 'ECFIRMBOARD_DELETE' ) . "</a>";
											echo "</div>";
					            		echo "</div>";						                	
									echo "</div>";
							} // delete post / thread //////////////// */
							
							// check if it is the first post in a thread (parent_id == 0)
					        if ( $posting->parent_id == 0) {
								// check if user has moderator rights
								if ( $logUser->isModerator()) {
									// move thread /////////////////
									echo "<div class='efebPostMenuItem'>";
										echo "<div class='efebPostMenuIcon'>";
											echo "<img src='" . $_root . "components/com_ecboard/assets/threads/move.png' />";
					            		echo "</div>";						                	
										echo "<div class='efebPostMenuText'>";
											echo "<div class='efebPostMenuLinks'>";
												$menuLinkMoveTMP = "index.php?option=com_ecboard&view=moderation&task=move&catid="
													.$this->categorySlug."&thread=".$this->thread;
												$menuLinkMove = JRoute::_( $menuLinkMoveTMP);
												echo "<a href='".$menuLinkMove."'>" . JText::_( 'ECFIRMBOARD_MOVE' ) . "</a>";
											echo "</div>";
					            		echo "</div>";						                	
									echo "</div>";
									// move thread /////////////////									
						
									// sticky or unsticky thread ////////////////
									echo "<div class='efebPostMenuItem'>";
										echo "<div class='efebPostMenuIcon'>";
											echo "<img src='" . $_root . "components/com_ecboard/assets/threads/sticky.png' />";
					            		echo "</div>";						                	
										echo "<div class='efebPostMenuText'>";
											echo "<div class='efebPostMenuLinks'>";
												if ( $this->stickyStatus == 0) { // thread is not sticky
													$menuLinkStickyTMP = "index.php?option=com_ecboard&view=moderation&task=sticky&catid=".$this->categorySlug."&thread=".$this->thread;
													$menuLinkSticky = JRoute::_( $menuLinkStickyTMP);
													echo "<a href='".$menuLinkSticky."'>" . JText::_( 'ECFIRMBOARD_STICKY' ) . "</a>";
												}
												else {
													$menuLinkUnstickyTMP = "index.php?option=com_ecboard&view=moderation&task=unsticky&catid=".$this->categorySlug."&thread=".$this->thread;
													$menuLinkUnsticky = JRoute::_( $menuLinkUnstickyTMP);
													echo "<a href='".$menuLinkUnsticky."'>" . JText::_( 'ECFIRMBOARD_UNSTICKY' ) . "</a>";
												}
											echo "</div>";
					            		echo "</div>";						                	
									echo "</div>";
									// sticky or unsticky thread ////////////////
									
									// close thread ////////////////
									echo "<div class='efebPostMenuItem'>";
										echo "<div class='efebPostMenuIcon'>";
											echo "<img src='" . $_root . "components/com_ecboard/assets/threads/lock.png' />";
					            		echo "</div>";						                	
										echo "<div class='efebPostMenuText'>";
											echo "<div class='efebPostMenuLinks'>";
												if ( $this->lockedStatus == 0) { // thread is not locked
													$menuLinkLockTMP = "index.php?option=com_ecboard&view=moderation&task=lock&catid=".$this->categorySlug."&thread=".$this->thread;
													$menuLinkLock = JRoute::_( $menuLinkLockTMP);
													echo "<a href='".$menuLinkLock."'>" . JText::_( 'ECFIRMBOARD_LOCK' ) . "</a>";
												}
												else {
													$menuLinkUnlockTMP = "index.php?option=com_ecboard&view=moderation&task=unlock&catid=".$this->categorySlug."&thread=".$this->thread;
													$menuLinkUnlock = JRoute::_( $menuLinkUnlockTMP);
													echo "<a href='".$menuLinkUnlock."'>" . JText::_( 'ECFIRMBOARD_UNLOCK' ) . "</a>";
												}
											echo "</div>";
					            		echo "</div>";						                	
									echo "</div>";
									// close thread ////////////////
								}
					        }
                	echo "</div>";
                	echo "<br />";
                } // user is logged in. display menue in post ////////////// ?>
			</td>
			
			
			
    	</tr>
		<?php $rowColor = 2; $counter++; 
	endforeach;
	?>
</table>



<!-- Pagination Links -->
<table width="100%" class="pageslinks" style="margin-bottom: 0px;">
    <tr>
        <td class="pagination"> <?php echo $this->pagination->getPagesLinks(); ?> </td>
        <td class="pagination"> <?php echo $this->pagination->getPagesCounter(); ?> </td>
    </tr>
</table>
<!-- Pagination Links -->



<!-- Breadcrumb -->
<?php if ( $showBreadcrumbRow == "1") { ?>
	<table class="efebnoborder" style="margin-top: 5px;">
	    <tr>
	        <td class="efebnoborder"> <?php echo "<a href='$menuLinkHome'>" . $menuText . "</a>"; ?> </td>
	        <td class="efebnoborder"> <?php echo "&nbsp;&raquo;&nbsp;"; echo "<a href='$menuLinkCategory'>".$this->categoryName."</a>"; ?> </td>
	        <td class="efebnoborder"> <?php echo "&nbsp;&raquo;&nbsp;"; echo $this->subject; ?> </td>
	    </tr>
	</table>
<?php } ?>
<!-- Breadcrumb -->



<?php // Forum specific bottom banner
if ( $this->forumBannerBottom != "") {
	echo "<table width='100%' border='0' class='efebnoborder' style='margin-top:10px;'>";
	    echo "<tr>";
	    	echo "<td width='100%' align='center' class='efebnoborder'>"; ?>
					<script type='text/javascript'>
					<?php	echo $this->forumBannerBottom; ?>
					</script>
			<?php	echo "</td>";
	    echo "</tr>";
	echo "</table>";
} // Forum specific bottom banner ?>



<?php include( 'components/com_ecboard/includes/share.php'); ?>

<!-- HTML Box Bottom -->
<?php $htmlBoxThreadBottom = $params->get('htmlBoxThreadBottom', '');		
if ( $htmlBoxThreadBottom != "") {
	echo "<div class='efebHtmlBoxThreadBottom'>";
		echo $htmlBoxThreadBottom;
	echo "</div>";
} ?>
<!-- HTML Box Bottom -->

<?php include( 'components/com_ecboard/includes/footer.php'); ?>
</div>